package com.unis.inspectiontask.client;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.CheckCensusQueryVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@FeignClient(name = "inspectiontask-server")
@Component
@Api(value = "人员单位规避管理", tags = "人员单位规避管理维护")
public interface CheckPersonFeign {

	@ApiOperation(value = "检查人次", notes = "参数：规避人员，单位code、名称、rwid")
    @PostMapping(value = "/checkcensus")
    public ResponseWrapper checkcensus(@RequestBody CheckCensusQueryVO checkCensusQueryVO);
}
