package com.unis.inspectiontask.client;

import java.util.List;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.EvasionVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/** 
 * @ClassName: EvasionFeign 
 * @Description: 人员单位规避 Feign
 * @author LiuFeng 
 * @date 2019年8月24日 下午4:49:00  
 */

@FeignClient(name = "inspectiontask-server")
@Component
@Api(value = "人员单位规避管理", tags = "人员单位规避管理维护")
public interface EvasionFeign {

	@ApiOperation(value = "规避记录保存", notes = "参数：规避code列表、规避名称列表、rwid")
    @PostMapping(value = "/evasionRecords")
    public ResponseWrapper saveRecords(@RequestBody List<EvasionVO> evasionVOs);
	
	/**
	 * 
	 * @Title: evasionList 
	 * @Description: 规避人员，单位记录条件查询
	 * @param rwId
	 * @return ResponseWrapper
	 * @throws
	 */
	@ApiOperation(value = "规避记录查询", notes = "参数：任务id")
    @GetMapping(value = "/evasionList/{rwId}")
    public ResponseWrapper queryEvasionList(@PathVariable(value="rwId")String rwId);
	

}
