package com.unis.inspectiontask.client;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.PerformanceQueryVO;
import com.unis.inspectiontask.common.vo.PersonnelPerformanceQueryVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @author WangZL
 * @version 1.0
 * @Title PerformanceFeign
 * @ProjectName 履职情况表 PerformanceFeign
 * @Description
 * @date 2019/07/22 17点26分
 */
@FeignClient(name = "inspectiontask-server")
@Api(value = "履职情况表 ", tags = "履职情况表")
@Component
public interface PerformanceFeign {

	@ApiOperation(value = "履职情况-分页查询列表", notes = "参数：参数：人员信息列表，统计开始时间，统计结束时间")
	@PostMapping(value = "/performanceList/{pageNum}/{pageSize}")
	public ResponseWrapper getPerformancePage(@RequestBody PerformanceQueryVO performanceQueryVO, @PathVariable("pageNum")Integer pageNum, @PathVariable("pageSize") Integer pageSize) ;

	@ApiOperation(value = "人员履职-检查次数", notes = "参数：任务集合，字典code，字典集合")
	@PostMapping(value = "/personnelPerformanceNumber")
	public ResponseWrapper getPersonnelPerformanceNumber(@RequestBody PersonnelPerformanceQueryVO personnelPerformanceQueryVO) ;
}
