package com.unis.inspectiontask.common.vo;

import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/** 
 * @ClassName: DesignatedExtraction 
 * @Description: 单位指定抽取查询参数
 * @author LiuFeng 
 * @date 2019年8月26日 下午3:56:52  
 */

@Getter
@Setter
@ApiModel(value="单位指定抽取查询参数")
public class DesignatedQueryVO {

	/**
	 * 组长列表
	 */
	@ApiModelProperty("组长列表")
	private List<MemberVO> zzList;
	
	/**
	 * 组员列表
	 */
	@ApiModelProperty("组员列表")
	private List<MemberVO> zyList;
	
	/**
	 * 外部人员列表
	 */
	@ApiModelProperty("外部人员列表")
	private List<MemberVO> wbryList;
	
	/**
	 * 被检单位规避列表
	 */
	@ApiModelProperty("被检单位规避列表")
	private List<EvasionVO> bjdwgbList;

	/**
	 * 企业规避区域列表
	 */
	@ApiModelProperty("企业规避区域列表")
	private List<String> qygbqyList;

	/**
	 * 企业类型列表
	 */
	@ApiModelProperty("企业类型列表")
	private List<CompanyTypeVO> companyTypeList;
	
	/**
	 * 被检企业选择方式： 0、单一。1、组合
	 */
	@ApiModelProperty("被检企业选择方式： 0、单一。1、组合")
	private Integer bjqyxzfs;
	
	/**
	 * 组织id
	 */
	@ApiModelProperty("组织id")
	private String orgId;
	
	/**
	 * 组长数量
	 */
	@ApiModelProperty("被检单位数量")
	private Integer bjdwNumber; 
	



	@ApiModelProperty(value = "入统状态0：停用。1：启用", notes ="入统状态0：停用。1：启用", required = false)
	private Integer rtzt;

	@ApiModelProperty(value = "是否最高最低企业", notes ="是否最高最低企业", required = false)
	private String sfzdzgqy;

	@ApiModelProperty(value="是否具有收购资格0、否。1、有")
	private Integer sfjysgzg;
 
}
