package com.unis.inspectiontask.common.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/** 
 * @ClassName: MemberVO 
 * @Description: 检查组组员信息VO 
 * @author LiuFeng 
 * @date 2019年8月24日 下午5:04:14  
 */
@SuppressWarnings("serial")
@ApiModel(value = "检查组组员信息VO")
@Getter
@Setter
public class MemberVO extends BaseEntity{

	/**
	 * 主键ID
	 */
	@ApiModelProperty("主键ID")
	private Long id;
	/**
	 * 检查组ID
	 */
	@ApiModelProperty("检查组ID")
	private Long jczId;
	
	/**
	 * 组员名称
	 */
	@ApiModelProperty("组员名称")
	private String zyName;
	
	/**
	 * 组员id
	 */
	@ApiModelProperty("组员id")
	private String zyId;
	
	/**
	 * 组员部门
	 */
	@ApiModelProperty("组员部门")
	private String zyks;
	
	/**
	 * 组员单位 
	 */
	@ApiModelProperty("组员单位 ")
	private String zydw;
	
	/**
	 * 组员类型（0、组长。1、组员。2、外部人员）
	 */
	@ApiModelProperty("组员类型（0、组长。1、组员。2、外部人员）")
	private Integer zylx;
	
	/**
	 * 是否持证
	 */
	@ApiModelProperty("是否持证")
	private Integer isCz;

	@ApiModelProperty(value = "市级证书编号")
	private String cityCardNum;

	@ApiModelProperty(value = "国家证号")
	private String zfzbh;

    @ApiModelProperty(value = "人员手机号")
    private String rysjh;

	@ApiModelProperty(value = "人才库id")
	private String rckid;

	@ApiModelProperty(value = "座机")
	private String zj;
}
