package com.unis.inspectiontask.common.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * @ClassName: OrganizeVO
 * @Description: 被检单位VO
 * @author LiuFeng
 * @date 2019年8月24日 下午5:04:59
 */
@SuppressWarnings("serial")
@ApiModel(value = "检查组被检单位信息VO")
@Getter
@Setter
public class OrganizeVO extends BaseEntity {

	/**
	 * 检查组Id
	 */
	@ApiModelProperty("检查组Id")
	private Long jczId;

	/**
	 * 检查组被检单位Id
	 */
	@ApiModelProperty("检查组被检单位Id")
	private String bjdwId;

	/**
	 * 检查组被检单位名称
	 */
	@ApiModelProperty("检查组被检单位名称")
	private String bjdwName;

	/**
	 * 被检企业地址
	 */
	@ApiModelProperty(" 被检企业地址")
	private String bjdwAddress;

	/**
	 * 被检企业负责人
	 */
	@ApiModelProperty(" 被检企业负责人")
	private String bjdwFzr;

	/**
	 * 被检企业负责人联系方式
	 */
	@ApiModelProperty(" 被检企业负责人联系方式")
	private String bjdwFzrPhone;

	@ApiModelProperty(value = "粮食收购许可证")
	private String zzjgdm;

	@ApiModelProperty(value = "被检单位联系电话")
	private String bjdwLxdh;

	@ApiModelProperty(value = "检查时间")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	private String jcsj;

	@ApiModelProperty(value = "检查结果Id")
	private String jgId;

	@ApiModelProperty(value = "企业编码")
	private String qybm;

}
