package com.unis.inspectiontask.common.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;

/**
 * @author WangZL
 * @version 1.0
 * @Title PerformanceQueryTO
 * @ProjectName 履职情况表查询业务对象
 * @Description
 * @date 2019/07/22 17点26分
 */
@SuppressWarnings("serial")
@Getter
@Setter
@ApiModel("履职情况表查询业务对象")
public class PerformanceQueryVO {

	@ApiModelProperty(value = "持证情况：国家证、市级证", notes ="持证情况：国家证、市级证", required = false)
	private String czqk;

	@ApiModelProperty(value = "任务列表", notes ="任务列表", required = false)
	private List<String> rwIdList;

	@ApiModelProperty(value = "统计开始时间", notes ="统计开始时间", required = false)
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private String jcksDate;

	@ApiModelProperty(value = "统计结束时间", notes ="统计结束时间", required = false)
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private String jcjsDate;

	@ApiModelProperty(value = "工作单位-不能为空", notes ="工作单位-不能为空", required = false)
	private String zzjgmc;

	@ApiModelProperty(value = "人员属性(任务类型编号)-不能为空", notes ="人员属性(任务类型编号)-不能为空", required = false)
	private String rwlxId;

	@ApiModelProperty(value = "人员状态-不能为空", notes ="人员状态-不能为空", required = false)
	private String ryzt;

	@ApiModelProperty(value = "权限-不能为空", notes ="权限-不能为空", required = false)
	private String orgid;

	@ApiModelProperty(value = "人员编号", notes ="人员编号", required = false)
	private String rybh;

	@ApiModelProperty(value = "字典code", notes ="字典code", required = false)
	private String dictCode;

	@ApiModelProperty(value = "是否履职情况：1、是。0、否", notes ="是否履职情况：1、是。0、否", required = false)
	private Integer sflzqk;

	@ApiModelProperty(value = "结果列表", notes ="结果列表", required = false)
	private List<String> jgIdList;

	private Integer pageNum;

	private Integer pageSize;

	public PerformanceQueryVO(String czqk, List<String> rwIdList, String jcksDate, String jcjsDate, String zzjgmc, String rwlxId,
							  String ryzt, String orgid, String rybh, String dictCode, Integer sflzqk, List<String> jgIdList) {
		super();
		this.czqk = czqk;
		this.rwIdList = rwIdList;
		this.jcksDate = jcksDate;
		this.jcjsDate = jcjsDate;
		this.zzjgmc = zzjgmc;
		this.rwlxId = rwlxId;
		this.ryzt = ryzt;
		this.orgid = orgid;
		this.rybh = rybh;
		this.dictCode = dictCode;
		this.sflzqk = sflzqk;
		this.jgIdList = jgIdList;
	}

	public PerformanceQueryVO() {
	}
}
