package com.unis.inspectiontask.common.vo;

import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

//双随机抽取参数
@Getter
@Setter
@ApiModel(value="随机抽取企业查询信息")
public class RandomQueryVO {

	/**
	 * 人员规避列表
	 */
	@ApiModelProperty("人员规避列表")
	private List<EvasionVO> rygbList;
	
	/**
	 * 被检单位列表
	 */
	@ApiModelProperty("被检单位规避列表")
	private List<EvasionVO> bjdwgbList;
	
	/**
	 * 检查组规则
	 */
	@ApiModelProperty("检查组规则")
	private List<CheckRuleVO> jczgzList;
	
	/**
	 * 企业类型列表
	 */
	@ApiModelProperty("企业类型列表")
	private List<CompanyTypeVO> companyTypeList;
	
	/**
	 * 企业规避区域列表
	 */
	@ApiModelProperty("企业规避区域列表")
	private List<String> qygbqyList;
	
	/**
	 * 人员类型列表
	 * 新需求不需要人员类型列表，弃用
	 */
	@ApiModelProperty("人员类型列表")
	private List<String> rylx;

	/**
	 * 人员规避区域列表
	 */
	@ApiModelProperty("人员规避区域列表")
	private List<String> rygbqyList;
	
	/**
	 * 组织id
	 */
	@ApiModelProperty("组织id")
	private String orgId;
	
	/**
	 * 检查组数量
	 */
	@ApiModelProperty("检查组数量")
	private Integer jczsl;

	@ApiModelProperty("检查组要求 0：一致  1：不一致")
	private Integer zczyq;

	@ApiModelProperty("被检企业选择方式： 0、单一。1、组合")
	private Integer bjqyxzfs;

	@ApiModelProperty("任务类型id")
	private String rwlxId;


	@ApiModelProperty(value = "入统状态0：停用。1：启用", notes ="入统状态0：停用。1：启用", required = false)
	private Integer rtzt;

	@ApiModelProperty(value = "是否最高最低企业", notes ="是否最高最低企业", required = false)
	private String sfzdzgqy;

	@ApiModelProperty(value="是否具有收购资格0、否。1、有")
	private Integer sfjysgzg;
	
	public List<CheckRuleVO> getJczgzList(){

		if(zczyq == 0 && this.jczgzList != null && this.jczgzList .size()==1) {
			CheckRuleVO cRuleVO = this.jczgzList.get(0);
			for(int i = 0;i< (this.jczsl - 1);i++) {
				this.jczgzList.add(cRuleVO);
			}
		}
		return this.jczgzList;
	}
}
