package com.unis.inspectiontask.common.vo;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.unis.inspectiontask.common.vo.backlog.ReceiverCollectionVO;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
@Getter
@Setter
@ApiModel("变更对象")
public class TaskChangeVO {
	
	/**
	 * 文件id        
	 */
	@ApiModelProperty("id")
    private String id;

	/**
	 * 文件类型    0、附件、1文件
	 */
	@ApiModelProperty("任务id")
    private String rwId;
    
	/**
	 * 审批类型
	 */
	@ApiModelProperty("申请类型 1、延期。2、终止")
    private String sqlx;
    
	/**
	 * 延期到
	 */
	@ApiModelProperty("延期到")
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date yqd;

	/**
	 * 申请原因
	 */
	@ApiModelProperty("申请原因")
    private String sqyy;

	/**
	 * id
	 */
	@ApiModelProperty("提交人")
    private String tjr;

	/**
	 * id
	 */
	@ApiModelProperty("提交时间")
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date tjsj;

	/**
	 * id
	 */
	@ApiModelProperty("审核结果 1、通过，2、拒绝")
    private String shjg;

	/**
	 * id
	 */
	@ApiModelProperty("延期时间")
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date yqsj;

	/**
	 * id
	 */
	@ApiModelProperty("审核意见")
    private String shyj;

	/**
	 * id
	 */
	@ApiModelProperty("审批人")
    private String spr;
	
	/**
	 * id
	 */
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
	@ApiModelProperty(value = "审核时间", notes ="", required = false)
    private Date spsj;
	
	
	
	
	@ApiModelProperty(value = "待办详情跳转Url")
    private String itemUrl;
    
    @ApiModelProperty(value = "待办详情跳转参数")
    private String itemQuery;
    
    @ApiModelProperty(value = "待办标题")
    private String title;
    
    @ApiModelProperty(value = "事项详情Url")
	private String itemUrlHaveDone;
	
	@ApiModelProperty(value = "跳转详情参数")
	private String itemQueryHaveDone;
    
    @ApiModelProperty(value = "待办任务状态")
    private String backlogTaskStatus;
    
    @ApiModelProperty(value = "待办任务状态名称")
    private String statusName;
    
    @ApiModelProperty(value = "待办用户")
    List<ReceiverCollectionVO> userList;
    
    @ApiModelProperty(value = "已办处理人主键")
    private String handlerId; // 已办-处理人主键
}