package com.unis.inspectiontask.common.vo;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnore;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * 
 * @author 张琪
 * @description  日常检查任务查询条件
 * @date 2019-08-24
 */

@ApiModel(value = "检查任务查询->实体")
@Getter
@Setter
public class TaskQueryVO {
	/**
	 * 任务编号
	 */
	@ApiModelProperty("任务编号ID")
	private String rwId;
	/**
	 * 任务名称
	 */
	@ApiModelProperty("任务名称")
	private String rwName;
	
	/**
	 * 被检单位code
	 */
	@ApiModelProperty("被检单位ID")
	private String bjdwId;
	/**
	 * 被检单位名称
	 */
	@ApiModelProperty("被检单位名称")
	private String bjdwName;

	/**
	 * 任务类型
	*/
	@ApiModelProperty("任务类型")
	private String rwlx;
	
	/**
	 * 任务类型名称
	*/
	@ApiModelProperty("任务类型名称")
	private String rwlxName;
	
	/**
	 * 检单位ID
	 */
	@ApiModelProperty("检单位ID")
	private String jcdwId;
	/**
	 * 任务状态（0、待分配。1、待下发。2、已下发。3、已完成）
	 */
	@ApiModelProperty("任务状态（0、待分配。1、待下发。2、已下发。3、已完成。4、已超期。5、超期完成。  6、已归档。）")
	private Integer rwZt; 
	
	/**
	 * 检单位名称
	 */
	@ApiModelProperty("检单位名称")
	private String jcdwmc;

	/**
	 * 组织ID
	 */
	@ApiModelProperty("组织ID")
	private String orgId; 
	
	/**
	 * 检查时间段开始时间-结束时间
	 */
	@ApiModelProperty("检查开始时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	private Date jckssjDate;
	
	@ApiModelProperty("检查结束时间")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date jcjssjDate;

	/**
	 * 分页参数列表（状态0_任务派发    1_ 计划制定）
	 */
	@ApiModelProperty("分页状态（参数）")
	private Integer pageBootState; 
	
	@ApiModelProperty(value = "用户集合")
	private List<String> userIds;

	@JsonIgnore
	@ApiModelProperty("当前用户Id")
	private String userId;

	@JsonIgnore
	@ApiModelProperty("任务状态操作")
	private String rwZtOperate;
}
