package com.unis.inspectiontask.common.vo;

import java.util.Date;
import java.util.List;

import com.unis.inspectionplan.common.vo.InspectionplanVO;
import com.unis.inspectiontask.common.vo.backlog.ReceiverCollectionVO;

import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * @author 张琪
 * @date 2019年9月2日 上午10:57:04
 * @description
 */

@Getter
@Setter
@ApiModel("检查任务项目和检查组->实体")
public class TaskTeamVO extends BaseEntity  {

	/**
	 * 任务名称
	 */
	@ApiModelProperty("任务名称")
	private String rwName;

	/**
	 * 任务类型
	*/
	@ApiModelProperty("任务类型")
	private String rwlx;

	/**
	 * 任务类型名称
	*/
	@ApiModelProperty("任务类型名称")
	private String rwlxName;

	/**
	 * 任务编号
	 */
	@ApiModelProperty("任务编号")
	private String rwId;

	/**
	 * 检查单位id
	 */
	@ApiModelProperty("检查单位")
	private String jcdwId;

	/**
	 * 检查单位
	 */
	@ApiModelProperty("检查单位")
	private String jcdwmc;

	/**
	 * 计划编号
	 */
	@ApiModelProperty("计划编号")
	private String jhId;

	/**
	 * 被检单位选择类型（被检单位选择方式(0,单一 1，组合)）
	 */
	@ApiModelProperty("被检单位选择方式(0,单一 1，组合)")
	private Integer bjdwxzfs;

	/**	/**
	 * 检查项目类型（0、单项检查  1、综合检查）
	 */
	@ApiModelProperty("检查项目类型（0、单项检查  1、综合检查）")
	private Integer jcxmlx;

	/**
	 *检查方式（0，远程。1、现场）
	 */
	@ApiModelProperty("检查方式 0，远程。1、现场")
	private Integer jcfs;

	/**
	 * 检查组取得方式（0，指定。1、双随机。2、指定。）
	 */
	@ApiModelProperty("检查组取得方式（0，指定。1、双随机。2、指定被检单位。）")
	private Integer jczqdfs;

	/**
	 * 检查内容实体
	 */
	private List<CheckContentVO> checkContentVO;

	/**
	 * 检查任务项目
	 */
	private List<TaskCheckItemsVO> taskCheckItemsVO;

	/**
	 * 检查组
	 */
	private List<TeamVO> teamVOs;

	/**
	 * 检查单位
	 *
	 */
	private List<InspectionUnitVO> inspectionUnitVO;

	/**
	 * 检查计划实体类
	 */
	@ApiModelProperty(value = "检查计划实体类")
	private InspectionplanVO inspectionplanVO	;

	/**
	 * 是否分配
	 */
	@ApiModelProperty("是否分配检查组  (0,是 1,否)")
	private Integer sffp;

	/**
	 * 任务状态（0、待分配。1、待下发。2、已下发。3、已完成）
	 */
	@ApiModelProperty("任务状态（0、待分配。1、待下发。2、已下发。3、已完成）")
	private Integer rwZt;
	/**
	 * 检查时间段开始时间-结束时间
	 */
	@ApiModelProperty("检查开始时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	private Date jckssjDate;

	@ApiModelProperty("检查结束时间")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date jcjssjDate;

	/**
	 * 组织ID
	 */
	@ApiModelProperty("组织ID")
	private String orgId;

	@ApiModelProperty("文件")
    private List<FileVO> file;

	@ApiModelProperty(value = "待办详情跳转Url")
    private String itemUrl;

    @ApiModelProperty(value = "待办详情跳转参数")
    private String itemQuery;

    @ApiModelProperty(value = "事项详情Url")
	private String itemUrlHaveDone;

	@ApiModelProperty(value = "跳转详情参数")
	private String itemQueryHaveDone;



	@ApiModelProperty(value = "待办详情跳转Url")
    private String itemUrlTwo;

    @ApiModelProperty(value = "待办详情跳转参数")
    private String itemQueryTwo;

    @ApiModelProperty(value = "事项详情Url")
	private String itemUrlHaveDoneTwo;

	@ApiModelProperty(value = "跳转详情参数")
	private String itemQueryHaveDoneTwo;

    @ApiModelProperty(value = "待办用户")
    List<ReceiverCollectionVO> userList;

    @ApiModelProperty(value = "已办处理人主键")
    private String handlerId; // 已办-处理人主键

}
