/**
 * @Title: InspectionTeamVO.java
 * @Package com.unis.inspectiontask.common.vo
 * @Description:
 * @author LiuFeng
 * @date 2019年8月24日 下午5:00:23
 * @version V1.0
 */
package com.unis.inspectiontask.common.vo;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * @ClassName: TeamVO
 * @Description: 检查组VO
 * @author LiuFeng
 * @date 2019年8月24日 下午5:00:23
 */
@SuppressWarnings("serial")
@ApiModel(value = "检查组VO")
@Getter
@Setter
public class TeamVO extends BaseEntity{

	/**
	 * 主键id
	 */
	@ApiModelProperty("主键id")
	private Long id;
	/**
	 * 任务Id
	 */
	@ApiModelProperty("任务id")
	private String rwId;

	/**
	 * 检查组名称
	 */
	@ApiModelProperty("检查组名称")
	private String jczName;

	/**
	 * 检查组成员
	 */
	@ApiModelProperty("检查组成员")
	private List<MemberVO> members;

	@ApiModelProperty("检查组成员")
	LinkedHashMap memberMap;

	/**
	 * 检查组被检单位
	 */
	@ApiModelProperty("检查组被检单位")
	private List<OrganizeVO> organizes;

	/**
	 * 任务状态
	 */
	@ApiModelProperty(value = "任务状态")
	private Integer rwZt=1;
}
