package com.unis.inspectiontask.common.vo.backlog;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 
 * @Description：待办新增VO
 * @author：王帅
 * @date: 2020年1月7日 下午4:20:45
 */
@Data
@ApiModel(value = "BacklogDeleteVO（待办删除VO）")
public class BacklogDeleteVO implements Serializable {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "事项Id")
	private String itemId; // 事项Id

	@ApiModelProperty(value = "事项名称")
	private String itemName; // 事项名称

	@ApiModelProperty(value = "事项类型")
	private String itemType;// 事项类型

	@ApiModelProperty(value = "事项详情Url")
	private String itemUrl;// 事项详情url

	@ApiModelProperty(value = "系统标识")
	private String sysCode; // 系统标识

	@ApiModelProperty(value = "待办事项当前状态名称")
	private String itemStatusName; // 待办事项当前状态名称

	@ApiModelProperty(value = "待办事项当前状态码")
	private Integer itemStatus; // 待办事项当前状态码

	@ApiModelProperty(value = "发起人单位名称")
	private String companyName; // 发起人单位

	@ApiModelProperty(value = "接收人")
	private String receiver; // 接收人

	@ApiModelProperty(value = "接收人主键")
	private String receiverId; // 接收人主键

	@ApiModelProperty(value = "结束提醒字段")
	private String websock;

	@ApiModelProperty(value = "接收人所在部门")
	private String receiverOrgCode; // 接收人所在部门

	@ApiModelProperty(value = "发起人")
	private String submitter; // 提交人

	@ApiModelProperty(value = "发起人主键")
	private String submitterId; // 提交人主键

	@ApiModelProperty(value = "提交时间")
	private String reportDate;// 提交时间

	@ApiModelProperty(value = "详情跳转参数")
	private String itemQuery; // 详情跳转参数

	@ApiModelProperty(value = "已办详情跳转参数")
	private String itemQueryHaveDone; // 已办详情跳转
	
	@ApiModelProperty(value = "已办跳转url")
	private String itemUrlHaveDone; // 已办跳转url

	@ApiModelProperty(value = "处理人")
	private String handler; // 处理人

	@ApiModelProperty(value = "处理人主键")
	private String handlerId; // 处理人主键

	@ApiModelProperty(value = "处理时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date handlingTime; // 处理时间

	@ApiModelProperty(value = "是否pad 0否 1是 非必填")
	private String ispad;
	@ApiModelProperty(value = "类型名称")
	private String tyname;
}
