package com.unis.inspectiontask.common.vo.backlog;

import java.io.Serializable;
import java.util.Date;

import org.springframework.format.annotation.DateTimeFormat;

import com.unis.common.utils.CurrentUtil;
import com.unis.inspectiontask.common.constant.BacklogConstant;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value = "BacklogUpdateVO（待办修改VO）")
public class BacklogUpdateVO implements Serializable {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "是否pad 0否1是")
	private String ispad;

	@ApiModelProperty(value = "类型名称")
	private String tyname;

	@ApiModelProperty(value = "事项Id")
	private String itemId; // 事项Id

	@ApiModelProperty(value = "事项名称")
	private String itemName; // 事项名称

	@ApiModelProperty(value = "事项类型")
	private String itemType;// 事项类型

	@ApiModelProperty(value = "事项详情Url")
	private String itemUrl;// 事项详情url

	@ApiModelProperty(value = "系统标识")
	private String sysCode; // 系统标识

	@ApiModelProperty(value = "待办事项当前状态名称")
	private String itemStatusName; // 待办事项当前状态名称

	@ApiModelProperty(value = "待办事项当前状态码")
	private Integer itemStatus; // 待办事项当前状态码

	@ApiModelProperty(value = "处理人")
	private String handler; // 处理人

	@ApiModelProperty(value = "处理时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date handlingTime; // 处理时间

	@ApiModelProperty(value = "处理人主键")
	private String handlerId; // 处理人主键
	
	
	//初始化参数
	public void buildUpdateVO(BacklogUpdateVO updateVO) {
		updateVO.setSysCode(BacklogConstant.SERVICE_INSPECTION);
		updateVO.setHandler(CurrentUtil.getUserName());
		updateVO.setHandlingTime(new Date());
		updateVO.setHandlerId(CurrentUtil.getUserId());
	}
}
