package com.unis.inspectiontask.server.dao;

import com.unis.inspectiontask.common.vo.PerformanceQueryVO;
import com.unis.inspectiontask.common.vo.PerformanceVO;
import com.unis.inspectiontask.common.vo.PersonnelPerformanceQueryVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import java.util.List;

/**
 *  履职信息信息
 * @author WangZL
 */
@Transactional(rollbackFor = Exception.class)
@Repository
public interface PerformanceDao{

    /**
     * 获取履职情况列表
     * @param performanceQueryVO
     * @return
     */
    List<PerformanceVO> getPerformanceList(PerformanceQueryVO performanceQueryVO);

    /**
     * 检查次数
     * @param personnelPerformanceQueryVO
     * @return
     */
    Integer getPerformanceSum(PersonnelPerformanceQueryVO personnelPerformanceQueryVO);

    /**
     * 检查次数
     * @param personnelPerformanceQueryVO
     * @return
     */
    Integer getPerformanceListSum(PersonnelPerformanceQueryVO personnelPerformanceQueryVO);

}