package com.unis.inspectiontask.server.dao;

import java.util.ArrayList;
import java.util.List;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.PerformanceQueryVO;
import com.unis.inspectiontask.common.vo.ResultApplyQuery;

import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import com.unis.inspectiontask.common.vo.TaskQueryVO;
import com.unis.inspectiontask.common.vo.TaskVO;
import com.unis.inspectiontask.server.entity.TJcrwDO;

import tk.mybatis.mapper.common.Mapper;

@Repository
public interface TJcrwDao extends Mapper<TJcrwDO>{


    /**
     * 检查任务新增
     * @param taskVO
     * @return
     */
    int insertTaskEntity(TaskVO taskVO);

    int insertSelective(TJcrwDO record);


	/**
	 * 查询数据是否存在
	 * @param taskVO
	 * @return
	 */
	List<TaskVO> selectDateNo(TaskVO taskVO);

	/**
	 * 假删除
	 * @param rwId
	 */
	void delete(String rwId);

	/**
	 * 检查任务数据 删除
	 * @param taskVO
	 * @return
	 */
	public int deleteByEntity(TaskVO taskVO);

	/**
	 * @Title: selectTaskListByRybh
	 * @Description:
	 * @param @param rybh
	 * @param @return
	 * @return List<TaskVO>
	 * @throws
	 */
	List<TJcrwDO> selectTaskListByRybh(TJcrwDO tJcrwDO);

	List<TJcrwDO> selectValidTaskListByRybh(TJcrwDO tJcrwDO);


	/**
	 * 获取任务ID主键策略方法  计划编号+001 格式
	 * @param maxCodeById
	 * @param string
	 * @param i
	 * @return
	 */
	String getMaxCodeById(@Param("pstr")String pstr);

	/**
	 * 获取检查组详细信息
	 * @param taskVO
	 * @return
	 */
	TJcrwDO getTaskInfoAll(TaskVO taskVO);

	/**
	 * 修改下发状态
	 * @param taskVO
	 */
	void updateInspectionTask(TaskVO taskVO);

	/**
	 * @Title: updateTaskStatus
	 * @Description: 修改任务状态
	 * @param rwId
	 * @param rwZt
	 * @return Integer
	 * @throws
	 */
	Integer updateTaskStatus(@Param("rwId")String rwId, @Param("rwZt")Integer rwZt);

	/**
	 * @param taskQueryVO
	 * @return
	 */
	List<TJcrwDO> findPageList(TaskQueryVO taskQueryVO);

	/**
	 * 根据计划编号查询数据信息
	 * @param tJcrwDO
	 * @return
	 */
	List<TJcrwDO> getTaskDate(TJcrwDO tJcrwDO);



	/**
	 * @param tJcrwDO
	 *  超期完成 + 完成
	 */
	void updateByWc(TJcrwDO tJcrwDO);

	/**
	 * 归档保存
	 * @param tJcrwDO
	 */
	void saveByRwEntity(TJcrwDO tJcrwDO);

	/**
	 * @param tJcrwDO
	 * @return
	 */
	ArrayList<TJcrwDO> getPlan(TJcrwDO tJcrwDO);

	/**
	 * @param rwId
	 */
	void deleteOrgSfxs(String rwId);

	/**
	 * 通过检查组人员查询任务列表
	 * @param zyId
	 * @return
	 */
	List<String> getTaskListByZyId(@Param("zyId")String zyId);

	/**
	 * 通过任务列表查询组员人数
	 * @param list
	 * @return
	 */
    Integer getCountByRwIdList(List<String> list);

	/**
	 * 根据计划编号和被检单位编号查询任务列表
	 * @param jhId
	 * @param bjdwId
	 * @return
	 */
	List<TJcrwDO> getTaskInfoByjhId(@Param("jhId")String jhId, @Param("bjdwId")String bjdwId);

	/**
	 * @param taskVO
	 * 进行本级单位删除
	 * @return
	 */
	int deleteByBjdwId(TaskVO taskVO);


	Integer updateTaskStatusAndDate(TaskVO taskVO);

	List<String> taskList(ResultApplyQuery taskChangeVO);

	void updateCkr(TJcrwDO tJcrwDO);

	List<String> getPlanJCJG(@Param("jhId")String jhId,@Param("rwId")String rwId,@Param("jgTbbhStr")String jgTbbhStr);
}
