package com.unis.inspectiontask.server.dao;

import com.unis.inspectiontask.server.entity.TJczDO;

import tk.mybatis.mapper.common.Mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

public interface TJczDao extends Mapper<TJczDO>{

    int insert(TJczDO record);

    int insertSelective(TJczDO record);

	/**
	 * @Title: selectByTaskId
	 * @Description:
	 * @param 根据检查任务id查询检查组列表
	 * @return List<TJczDO>
	 * @throws
	 */
	List<TJczDO> selectByTaskId(String taskId);

	/**
	 * @Title: selectByRwIdAndBjdwId
	 * @Description: 根据任务编号和被检单位id查询检查组信息
	 * @param rwId 任务编号
	 * @param bjdwId 被检单位id
	 * @return List<TJczDO>
	 * @throws
	 */
	TJczDO selectInspectionTeam(@Param("rwId")String rwId, @Param("bjdwId")String bjdwId);

	/**
	 * 删除任务ID
	 * @param rwId
	 */
	void deleteTeam(String rwId);
}
