package com.unis.inspectiontask.server.domain;

import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.LsBeanUtils;
import com.unis.inspectiontask.common.vo.CheckCensusQueryVO;
import com.unis.inspectiontask.common.vo.CheckCensusVO;
import com.unis.inspectiontask.common.vo.CheckOrgVO;
import com.unis.inspectiontask.server.dao.CheckCensusDao;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author WangZL
 * @version 1.0
 * @Title FileDomain
 * @ProjectName 持久化
 * @Description
 * @date 2019/07/22 17点26分
 */
@Component
public class CheckCensusDomain {

	@Autowired
	private CheckCensusDao checkCensusDao;

	public List<CheckCensusVO> checkcensus(CheckCensusQueryVO checkCensusQueryVO) {
		List<CheckCensusVO> censusVOs = new ArrayList<CheckCensusVO>();
		if(CurrentUtil.getOrgId().equals("LS001")) {
			checkCensusQueryVO.setOrgId("LS001");
		} else {
			checkCensusQueryVO.setOrgId(null);
		}
		for(CheckOrgVO checkOrgVO :checkCensusQueryVO.getOrgVOs()) {
			checkCensusQueryVO.setDwDm(checkOrgVO.getDwDm());
			CheckCensusVO checkCensusVO = checkCensusDao.getInfo(checkCensusQueryVO);
			if(checkCensusVO==null) {
				checkCensusVO = new CheckCensusVO();
				checkCensusVO.setDwDm(checkOrgVO.getDwDm());
				checkCensusVO.setDwMc(checkOrgVO.getDwMc());
			} else {
				checkCensusVO.setDwDm(checkOrgVO.getDwDm());
				checkCensusVO.setDwMc(checkOrgVO.getDwMc());
			}
			censusVOs.add(checkCensusVO);
		}
		return censusVOs;
	}

}
