/**
 * @Title: EvasionDomain.java
 * @Package com.unis.inspectiontask.server.domain
 * @Description:
 * @author LiuFeng
 * @date 2019年8月24日 下午2:47:56
 * @version V1.0
 */
package com.unis.inspectiontask.server.domain;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.unis.inspectiontask.common.vo.EvasionQueryVO;
import com.unis.inspectiontask.common.vo.EvasionVO;
import com.unis.inspectiontask.server.dao.TRydwgbDao;

import lombok.Data;

/**
 * @ClassName: EvasionDomain
 * @Description: 规避管理 Domain
 * @author LiuFeng
 * @date 2019年8月24日 下午2:47:56
 */
@Data
@Component
public class EvasionDomain {

	@Autowired
	private TRydwgbDao rydwgbDao;

	/**
	 * @Title: saveRecords
	 * @Description: 批量插入保存规避记录
	 * @param evasionVOs
	 * @return int
	 * @throws
	 */
	public int saveRecords(List<EvasionVO> evasionVOs) {

		return rydwgbDao.insertList(evasionVOs);
	}

	/**
	 * @Title: queryRecordsList
	 * @Description:
	 * @param queryVO
	 * @return List<EvasionVO>
	 * @throws
	 */
	public List<EvasionVO> queryRecordsList(EvasionQueryVO queryVO) {

		return rydwgbDao.selectByEvasionQueryVO(queryVO);
	}

	/**
	 * @Title: queryRecordsByRwId
	 * @Description:
	 * @param @param rwId
	 * @param @return
	 * @return List<EvasionVO>
	 * @throws
	 */
	public List<EvasionVO> queryRecordsByRwId(String rwId) {
		EvasionQueryVO queryVO = new EvasionQueryVO();
		if(StringUtils.isNotBlank(rwId)) {
			queryVO.setRwId(rwId);
		}
		return rydwgbDao.selectByEvasionQueryVO(queryVO);
	}


}
