package com.unis.inspectiontask.server.domain;


import com.unis.inspectiontask.common.vo.PerformanceQueryVO;
import com.unis.inspectiontask.common.vo.PerformanceVO;
import com.unis.inspectiontask.common.vo.PersonnelPerformanceQueryVO;
import com.unis.inspectiontask.server.dao.PerformanceDao;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author WangZL
 * @version 1.0
 * @Title PerformanceDomain
 * @ProjectName 持久化
 * @Description
 * @date 2019/07/22 17点26分
 */
@Getter
@Setter
@ToString
@Component
public class PerformanceDomain extends BaseDomain {

	@Autowired
	private PerformanceDao performanceDao;

	/**
	 * 获取履职情况列表
	 * @param performanceQueryVO
	 * @return
	 */
	public List<PerformanceVO> getPerformanceList(PerformanceQueryVO performanceQueryVO) {
		return performanceDao.getPerformanceList(performanceQueryVO);
	}

	/**
	 * 检查次数
	 * @param personnelPerformanceQueryVO
	 * @return
	 */
	public Integer personnelPerformanceNumber(PersonnelPerformanceQueryVO personnelPerformanceQueryVO) {
		Integer number = 0;
		if (personnelPerformanceQueryVO.getDictCodeList() != null){
			number = performanceDao.getPerformanceListSum(personnelPerformanceQueryVO);
		} else if (personnelPerformanceQueryVO.getDictCode() != null){
			number = performanceDao.getPerformanceSum(personnelPerformanceQueryVO);
		}
		return number;
	}
}
