package com.unis.inspectiontask.server.domain;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.Lists;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.DateUtil;
import com.unis.common.utils.LsBeanUtils;
import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.constant.TaskStatusConstant;
import com.unis.inspectiontask.common.vo.*;
import com.unis.inspectiontask.server.dao.*;
import com.unis.inspectiontask.server.entity.*;
import com.unis.inspectiontask.server.service.mq.BacklogMQService;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;
import tk.mybatis.mapper.entity.Example.Criteria;

import java.util.*;
import java.util.stream.Collectors;

@Getter
@Setter
@ToString
@Component
public class TaskDomain extends BaseDomain{
	@Autowired
	private TJcrwDao tJcrwDao;
	@Autowired
	private TJcnrDao tJcnrDao;
	@Autowired
	private TRwjcxmDao tRwjcxmDao;
	@Autowired
	private TBjdwDao tBjdwDao;
	@Autowired
	private TJczDao tJczDao;
	@Autowired
	private TFileDao fileDao;
	@Autowired
	private TJczzyDao tJczzyDao;
	@Autowired
	private TeamDomain teamDomain;

	@Autowired
	private TaskChangeDao taskChangeDao;

	@Autowired
	private BacklogMQService backlogService;
	/**
	 * 分页查询列表
	 * @param taskQueryVO
	 * @return
	 */
	public PageInfo<TaskVO> getTasksByQuery(TaskQueryVO taskQueryVO,Integer pageNum,Integer pageSize) {
		String userId =  CurrentUtil.getUserId();
		taskQueryVO.setUserId(userId);

		PageInfo<TaskVO> pageInfoVO = new PageInfo<TaskVO>();
		PageHelper.startPage(pageNum, pageSize);
		List<TJcrwDO> tJcrwDOs =  tJcrwDao.findPageList(taskQueryVO);
		PageInfo<TJcrwDO> PageInfoDO = new PageInfo<TJcrwDO>(tJcrwDOs);

		LsBeanUtils.copyAllProperties(PageInfoDO,pageInfoVO);

		List<TaskVO> taskVOs = new ArrayList<TaskVO>();

		for(TJcrwDO tJcrwDO :tJcrwDOs) {
			TaskVO taskVO = new TaskVO();
			/*//任务检查内容查询
			ArrayList<CheckContentVO> checkContentVOList = new ArrayList<CheckContentVO>();
			List<TJcnrDO> tJcnrDOList = tJcnrDao.selectByQuery(tJcrwDO.getRwId());
			for (TJcnrDO tJcnrDO : tJcnrDOList) {
				CheckContentVO vo = new CheckContentVO();
				LsBeanUtils.copyAllProperties(tJcnrDO, vo);
				checkContentVOList.add(vo);
			}

			taskVO.setCheckContentVO(checkContentVOList);*/

		/*	//检查组组员
			ArrayList<MemberVO> memberVOList = new ArrayList<MemberVO>();
			TJczzyDO tJczzyD=new TJczzyDO();
			tJczzyD.setRemark(tJcrwDO.getRwId());
			List<TJczzyDO> tJczzyDOList = tJczzyDao.selectByQuery(tJczzyD);
			for (TJczzyDO tJczzyDO : tJczzyDOList) {
				MemberVO vo = new MemberVO();
				LsBeanUtils.copyAllProperties(tJczzyDO, vo);
				memberVOList.add(vo);
			}
			taskVO.setMembers(memberVOList);*/

			/*//任务检查子项目查询
			ArrayList<TaskCheckItemsVO> taskCheckItemsVOList = new ArrayList<TaskCheckItemsVO>();
			List<TRwjcxmDO> tRwjcxmDOList =tRwjcxmDao.selectByQuery(tJcrwDO.getRwId());
			for (TRwjcxmDO tRwjcxmDO : tRwjcxmDOList) {
				TaskCheckItemsVO vo = new TaskCheckItemsVO();
				LsBeanUtils.copyAllProperties(tRwjcxmDO, vo);
				taskCheckItemsVOList.add(vo);
			}

			taskVO.setTaskCheckItemsVO(taskCheckItemsVOList);*/

			/*//被检查单位查询
			ArrayList<InspectedUnitsVO> inspectedUnitsVOList  = new ArrayList<InspectedUnitsVO>();
			List<TBjdwDO>tBjdwDOList=tBjdwDao.selectByQuery(tJcrwDO.getRwId());
			for (TBjdwDO tBjdwDO : tBjdwDOList) {
				InspectedUnitsVO vo = new InspectedUnitsVO();
				LsBeanUtils.copyAllProperties(tBjdwDO, vo);
				inspectedUnitsVOList.add(vo);
			}
			taskVO.setInspectedUnitsVO(inspectedUnitsVOList);*/

			/*// 给任务VO添加文件list
			List<FileVO> FileVOList = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(tJcrwDO.getRwId());
			for (TFileDO tFileDO : doList4) {
				FileVO fileVO = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, fileVO);
				FileVOList.add(fileVO);
			}
			taskVO.setFile(FileVOList);*/
			LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);
			taskVOs.add(taskVO);

		}
		pageInfoVO.setList(taskVOs);
		return pageInfoVO;
	}

	/**
	 * 根据任务编号查询详单
	 * @param rwId
	 * @return
	 */
	public TaskVO getTaskInfoByrwbh(String rwId) {
		TJcrwDO tJcrwDO = tJcrwDao.selectByPrimaryKey(rwId);
		if (tJcrwDO == null) {
			return null;
		}
		if(tJcrwDO.getRwZt()==0) {//待分配
			if(org.apache.commons.lang3.StringUtils.isNotEmpty(tJcrwDO.getSfck())&&tJcrwDO.getSfck().equals("0")) {
				if(!CurrentUtil.getOrgId().equals("LS001")) {
					tJcrwDO.setCkr(CurrentUtil.getUserName());
					tJcrwDO.setCksj(new Date());
					tJcrwDao.updateCkr(tJcrwDO);
				}
			}
		}

		TaskVO taskVO=new TaskVO();
		//任务检查主表查询
		LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);


		//任务检查内容查询
		ArrayList<CheckContentVO> checkContentVOList = new ArrayList<CheckContentVO>();
		List<TJcnrDO> tJcnrDOList = tJcnrDao.selectByQuery(tJcrwDO.getRwId());
		for (TJcnrDO tJcnrDO : tJcnrDOList) {
			CheckContentVO vo = new CheckContentVO();
			LsBeanUtils.copyAllProperties(tJcnrDO, vo);
			checkContentVOList.add(vo);
		}

		taskVO.setCheckContentVO(checkContentVOList);

		//任务检查子项目查询
		ArrayList<TaskCheckItemsVO> taskCheckItemsVOList = new ArrayList<TaskCheckItemsVO>();
		List<TRwjcxmDO> tRwjcxmDOList =tRwjcxmDao.selectByQuery(tJcrwDO.getRwId());
		for (TRwjcxmDO tRwjcxmDO : tRwjcxmDOList) {
			TaskCheckItemsVO vo = new TaskCheckItemsVO();
			LsBeanUtils.copyAllProperties(tRwjcxmDO, vo);
			taskCheckItemsVOList.add(vo);
		}

		taskVO.setTaskCheckItemsVO(taskCheckItemsVOList);

		//被检查单位查询
		ArrayList<InspectedUnitsVO> inspectedUnitsVOList  = new ArrayList<InspectedUnitsVO>();
		List<TBjdwDO>tBjdwDOList=tBjdwDao.selectByQuery(tJcrwDO.getRwId());
		for (TBjdwDO tBjdwDO : tBjdwDOList) {
			InspectedUnitsVO vo = new InspectedUnitsVO();
			LsBeanUtils.copyAllProperties(tBjdwDO, vo);
			inspectedUnitsVOList.add(vo);
		}
		taskVO.setInspectedUnitsVO(inspectedUnitsVOList);

		//检查组组员
		ArrayList<MemberVO> memberVOList = new ArrayList<MemberVO>();
		TJczzyDO tJczzyD=new TJczzyDO();
		tJczzyD.setRemark(tJcrwDO.getRwId());
		List<TJczzyDO> tJczzyDOList = tJczzyDao.selectByQuery(tJczzyD);
		for (TJczzyDO tJczzyDO : tJczzyDOList) {
			MemberVO vo = new MemberVO();
			LsBeanUtils.copyAllProperties(tJczzyDO, vo);
			memberVOList.add(vo);
		}
		taskVO.setMembers(memberVOList);
		// 获取检查文件列表
		List<FileVO> voList4 = new ArrayList<FileVO>();
		List<TFileDO> doList4 = fileDao.selectBySjid(tJcrwDO.getRwId());
		for (TFileDO tFileDO : doList4) {
			FileVO vo = new FileVO();
			LsBeanUtils.copyAllProperties(tFileDO, vo);
			voList4.add(vo);
		}
		taskVO.setFile(voList4);


		taskVO.setChangeVOs(taskChangeDao.selectRwBgList(tJcrwDO.getRwId()));
		return taskVO;
	}

	/**
	 * 导出查询方法
	 * @param taskQueryVO
	 * @return
	 */
	public List<TaskVO> findExportList(TaskQueryVO taskQueryVO) {
		List<TaskVO> taskVOs = new ArrayList<TaskVO>();
		List<TJcrwDO> tJcrwDOs =  tJcrwDao.findPageList(taskQueryVO);
		LsBeanUtils.copyCollection(tJcrwDOs, taskVOs, TaskVO.class);
		return taskVOs;
	}

	/**
	 * 检查数据新增
	 * @param taskVO
	 */
	public void insert(TaskVO taskVO) {
		taskVO.setSfck("0");
		tJcrwDao.insertTaskEntity(taskVO);
	}
	/**
	 * 任务检查数据-删除
	 * @param rwId
	 */
	public void delete(String rwId) {
		tJcrwDao.delete(rwId);
	}

	/**
	 * 检查任务数据 删除
	 * @param taskVO
	 * @return
	 */
	public ResponseWrapper deleteByEntity(TaskVO taskVO){
		int  num= tJcrwDao.deleteByEntity(taskVO);
		if(StringUtils.isNotEmpty(taskVO.getJcdwId())) {//检查单位id存在表示此任务为本级任务
			//进行本级任务更新
			num = tJcrwDao.deleteByBjdwId(taskVO);
		}
		return ResponseWrapper.choose(num);
	}

	/**
	 * @param taskVO
	 * @return
	 */
	public List<TaskVO> selectDateNo(TaskVO taskVO) {
		return tJcrwDao.selectDateNo(taskVO);
	}



	public List<TaskVO> getTaskSimpleListByRybh(String rybh, String rwlx) {
		TJcrwDO tJcrwD=new TJcrwDO();
		tJcrwD.setRemark(rybh);
		tJcrwD.setRwlx(rwlx);
		tJcrwD.setJcdwId(CurrentUtil.getOrgId());
		List<TJcrwDO> rwDOList = tJcrwDao.selectValidTaskListByRybh(tJcrwD);
		List<TaskVO>  list= new ArrayList<>();
		for(TJcrwDO rwdo : rwDOList){
			TaskVO taskVO = new TaskVO();
			LsBeanUtils.copyAllProperties(rwdo, taskVO);
			list.add(taskVO);
		}
		return list;
	}

	/**
	 * @param rwlx
	 * @Title: getTaskListByRybh
	 * @param @param rybh
	 * @param @return
	 * @return List<TaskVO>
	 * @throws
	 */
	public List<TaskVO> getTaskListByRybh(String rybh, String rwlx) {
		TJcrwDO tJcrwD=new TJcrwDO();
		tJcrwD.setRemark(rybh);
		tJcrwD.setRwlx(rwlx);
		tJcrwD.setJcdwId(CurrentUtil.getOrgId());
		List<TJcrwDO> rwDOList = tJcrwDao.selectTaskListByRybh(tJcrwD);
		//子表
		List<TaskVO> taskVOs = new ArrayList<>();

		for(TJcrwDO tJcrwDO :rwDOList) {
			TaskVO taskVO = new TaskVO();
			//任务检查内容查询
			ArrayList<CheckContentVO> checkContentVOList = new ArrayList<CheckContentVO>();
			List<TJcnrDO> tJcnrDOList = tJcnrDao.selectByQuery(tJcrwDO.getRwId());
			for (TJcnrDO tJcnrDO : tJcnrDOList) {
				CheckContentVO vo = new CheckContentVO();
				LsBeanUtils.copyAllProperties(tJcnrDO, vo);
				checkContentVOList.add(vo);
			}

			taskVO.setCheckContentVO(checkContentVOList);

			//检查组组员
			ArrayList<MemberVO> memberVOList = new ArrayList<MemberVO>();
			TJczzyDO tJczzyD=new TJczzyDO();
			tJczzyD.setRemark(tJcrwDO.getRwId());
			List<TJczzyDO> tJczzyDOList = tJczzyDao.selectByQuery(tJczzyD);
			for (TJczzyDO tJczzyDO : tJczzyDOList) {
				MemberVO vo = new MemberVO();
				LsBeanUtils.copyAllProperties(tJczzyDO, vo);
				memberVOList.add(vo);
			}
			taskVO.setMembers(memberVOList);

			//任务检查子项目查询
			ArrayList<TaskCheckItemsVO> taskCheckItemsVOList = new ArrayList<TaskCheckItemsVO>();
			List<TRwjcxmDO> tRwjcxmDOList =tRwjcxmDao.selectByQuery(tJcrwDO.getRwId());
			for (TRwjcxmDO tRwjcxmDO : tRwjcxmDOList) {
				TaskCheckItemsVO vo = new TaskCheckItemsVO();
				LsBeanUtils.copyAllProperties(tRwjcxmDO, vo);
				taskCheckItemsVOList.add(vo);
			}

			taskVO.setTaskCheckItemsVO(taskCheckItemsVOList);

			//被检查单位查询
			ArrayList<InspectedUnitsVO> inspectedUnitsVOList  = new ArrayList<InspectedUnitsVO>();
			List<TBjdwDO>tBjdwDOList=tBjdwDao.selectByQuery(tJcrwDO.getRwId());
			for (TBjdwDO tBjdwDO : tBjdwDOList) {
				InspectedUnitsVO vo = new InspectedUnitsVO();
				LsBeanUtils.copyAllProperties(tBjdwDO, vo);
				inspectedUnitsVOList.add(vo);
			}
			taskVO.setInspectedUnitsVO(inspectedUnitsVOList);

			// 给任务VO添加文件list
			List<FileVO> FileVOList = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(tJcrwDO.getRwId());
			for (TFileDO tFileDO : doList4) {
				FileVO fileVO = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, fileVO);
				FileVOList.add(fileVO);
			}
			taskVO.setFile(FileVOList);
			LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);
			taskVOs.add(taskVO);
		}
		return taskVOs;
	}

	/**
	 * 查询详细信息
	 * @param taskVO
	 * @return
	 */

	public TaskVO getTaskInfoAll(TaskVO taskVO) {
		TJcrwDO tJcrwDO = tJcrwDao.getTaskInfoAll(taskVO);
		if(tJcrwDO == null) {
			return null;
		}
		taskVO = this.getTaskInfoByrwbh(tJcrwDO.getRwId());
		LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);
		return taskVO;
	}

	/**
	 * @param taskVO
	 * @return
	 */
	public int inspectionTaskInsert(TaskVO taskVO) {

		/**
		 * 		   逻辑：只更新主表  触发：下发操作
		 *             1.选择分配检查组（是）下发操作  默认是否显示状态 0 （显示）------更新流程状态   1（待下发 ）
		 *             2.选择分配检查组（否）下发操作  更新是否显示状态  0（显示）------更新流程状态   0（待分配）
		 *             3.首先.选择分配检查组（是） 、默认是否显示（隐藏） 更新为否     删除掉数据
		 */
		//查询是否存在该数据（不存在新增 存在更新）
		//1.判断数据不存在
		taskVO.setSfxs(0);
		taskVO.setStatus(1);
		if(StringUtils.isEmpty(taskVO.getJhId())&& StringUtils.isEmpty(taskVO.getJcdwId())) {
			return -1;
		}
		//是
		taskVO.setRwZt(Integer.parseInt(TaskStatusConstant.TO_FP.getValue()));
		if (taskVO.getSffp()==0&&taskVO.getJcdwId().equals(CurrentUtil.getOrgId())) {
			taskVO.setRwZt(Integer.parseInt(TaskStatusConstant.ARYXF.getValue()));
		}


		TJcrwDO 	tJcrwDO=tJcrwDao.getTaskInfoAll(taskVO);
		if (taskVO.getJcdwId().equals(CurrentUtil.getOrgId())&&tJcrwDO!=null) {
			tJcrwDO.setSfxs(0);
			tJcrwDO.setJcdwmc(taskVO.getJcdwmc());
			tJcrwDO.setStatus(Integer.parseInt(TaskStatusConstant.XF.getValue()));
			tJcrwDao.updateByPrimaryKeySelective(tJcrwDO);
		}else {
	        taskVO.setRwId(this.getMaxCodeById(tJcrwDao.getMaxCodeById(taskVO.getJhId()), taskVO.getJhId(), 3));
	        taskVO.setSfck("0");
	        tJcrwDao.insertTaskEntity(taskVO);
		}

		return 1;

	}


	/**
	 * 分配暂存
	 * @param taskVO
	 */
	public int inspectionTaskDistribution(TaskVO taskVO) {
		taskVO.setSfck("0");
		//先判断是否是分配或者编辑
		if(StringUtils.isEmpty(taskVO.getRwId())) {
			return -1;
		}
		TJcrwDO tJcrwDO =new TJcrwDO();
		LsBeanUtils.copyAllProperties(taskVO, tJcrwDO);
		tJcrwDao.updateByPrimaryKeySelective(tJcrwDO);
			//判断检查内容是否为空
		if(taskVO.getCheckContentVO()!=null) {
			tJcnrDao.deleteByRwKey(taskVO.getRwId());
			TJcnrDO tJcnrDO=new TJcnrDO();
			for (CheckContentVO checkContentVOList : taskVO.getCheckContentVO()) {
				tJcnrDO.setId(new Double(Math.round(Math.random()*500*100)).longValue());
				tJcnrDO.setRwId(taskVO.getRwId());
				tJcnrDO.setJcnrId(checkContentVOList.getJcnrId());
				tJcnrDO.setJcnrName(checkContentVOList.getJcnrName());
				tJcnrDO.setCreateDate(taskVO.getCreateDate());
				tJcnrDO.setCreator(taskVO.getUserName());
				tJcnrDO.setCreatorCode(taskVO.getUserId());
				tJcnrDO.setRefresher(taskVO.getUserName());
				tJcnrDO.setRefreshTime(taskVO.getCreateDate());
				tJcnrDO.setRefresherCode(taskVO.getUserId());
				tJcnrDO.setStatus(1);
				CheckContentVO checkContentVO=new CheckContentVO();
				LsBeanUtils.copyAllProperties(tJcnrDO, checkContentVO);
				this.inspectionJcnrSave(checkContentVO);
			}
		}
		//判断检查子项目是否为空
		if(taskVO.getTaskCheckItemsVO()!=null) {
			tRwjcxmDao.deleteByRwKey(taskVO.getRwId());
			TRwjcxmDO tRwjcxmDO=new TRwjcxmDO();
			for (TaskCheckItemsVO taskCheckItemsVOList : taskVO.getTaskCheckItemsVO()) {
				tRwjcxmDO.setId(new Double(Math.round(Math.random()*500*100)).longValue());
				tRwjcxmDO.setRwId(taskVO.getRwId());
				tRwjcxmDO.setJcxmId(taskCheckItemsVOList.getJcxmId());
				tRwjcxmDO.setJcxmName(taskCheckItemsVOList.getJcxmName());
				tRwjcxmDO.setCreateDate(taskVO.getCreateDate());
				tRwjcxmDO.setCreator(taskVO.getCreator());
				tRwjcxmDO.setCreatorCode(taskVO.getCreatorCode());
				tRwjcxmDO.setRefresher(taskVO.getRefresher());
				tRwjcxmDO.setRefreshTime(taskVO.getRefreshTime());
				tRwjcxmDO.setRefresherCode(taskVO.getRefresherCode());
				tRwjcxmDO.setStatus(1);
				TaskCheckItemsVO taskCheckItemsVO=new TaskCheckItemsVO();
				LsBeanUtils.copyAllProperties(tRwjcxmDO, taskCheckItemsVO);
				this.insertCheckItems(taskCheckItemsVO);
			}
		}

		//保存检查组
		if(taskVO.getTeamVOs()!=null) {
			for(TeamVO  teamVO : taskVO.getTeamVOs()){
				teamVO.setRwId(taskVO.getRwId());
			}
			teamDomain.deleteTeam(taskVO.getRwId());
			teamDomain.saveInspectionTeams(taskVO.getTeamVOs(),null);
		}

		// 获得文件列表
		List<FileVO> file = taskVO.getFile();
		if (file == null) {
			return -1;
		}
		// 更改TFile原来数据库的status
		List<TFileDO> doList4 = fileDao.selectBySjid(taskVO.getRwId());
		if(doList4 != null){
			TFileDO fileDO = new TFileDO();
			fileDO.setSjId(taskVO.getRwId());
			fileDao.deleteBySjId(fileDO);
//			for (TFileDO tFileDO : doList4) {
//				tFileDO.setStatus(0);
//				fileDao.updateByPrimaryKeySelective(tFileDO);
//			}
		}
		// 新增TFileDO
		List<FileVO> voList4 = taskVO.getFile();
		if(voList4 != null){
			for (FileVO fileVO : voList4) {
				TFileDO tFileDO = new TFileDO();
				fileVO.setSjId(taskVO.getRwId());
				fileVO.setStatus(1);
				LsBeanUtils.copyAllProperties(fileVO, tFileDO);
				fileDao.insertSelective(tFileDO);
			}
		}
			return 1;
	}


	/**
	 * @Title: updateTaskStatus
	 * @Description: 修改任务状态
	 * @param rwId
	 * @param rwZt
	 * @return Integer
	 * @throws
	 */
	public Integer updateTaskStatus(String rwId, Integer rwZt) {
		return tJcrwDao.updateTaskStatus(rwId,rwZt);
	}
	/**
	 * @param taskTeamVO
	 *  检查组和检查任务新增接口
	 * @return
	 */
	@Transactional
	public String inspectionTaskInsertTeam(TaskTeamVO taskTeamVO) {
			return taskTeamVO.getRwId();
    	}


	/**
	 * 回撤返回状态 200 代表回撤成功  400代表回撤失败
	 * @param jhId
	 */
	public List<TaskVO> getTaskDate(String jhId) {
		TaskVO taskV=new TaskVO();
		taskV.setJhId(jhId);
		taskV.setRwZt(Integer.parseInt( TaskStatusConstant.TO_DXF.getValue()));
		TJcrwDO tJcrwDO=new TJcrwDO();
		LsBeanUtils.copyAllProperties(taskV,tJcrwDO);
		List<TJcrwDO> tJcrwDOs= tJcrwDao.getTaskDate(tJcrwDO);
		//如果完成的存在一个大于0就全部
		List<TaskVO> taskVOs = new ArrayList<TaskVO>();
		if(tJcrwDOs.size()==0) {
				//获取任务编号假删
			    List<TaskVO> selectDateNo = tJcrwDao.selectDateNo(taskV);
			    if (selectDateNo != null) {
			    	List<TJcrwDO> tJcrwD= new ArrayList<TJcrwDO>();
			    	LsBeanUtils.copyCollection(selectDateNo, tJcrwD, TJcrwDO.class);
			        for (TJcrwDO taskVO : tJcrwD) {
						if (taskVO.getJcdwId().equals(CurrentUtil.getOrgId())) {
							//如果是OrgID  隐藏
							tJcrwDao.deleteOrgSfxs(taskVO.getRwId());
						}else {
							//否则假删除
							tJcrwDao.delete(taskVO.getRwId());
						}
					}
				}
		}
		LsBeanUtils.copyCollection(tJcrwDOs, taskVOs, TaskVO.class);
		return taskVOs;
	}


	/**
	 * 更新任务状态
	 * @param taskVO
	 * @return
	 */
	public TaskVO inspectionTaskUpdateByEntity(TaskVO taskVO) {
		TJcrwDO tJcrwDO =new TJcrwDO();
		LsBeanUtils.copyAllProperties(taskVO, tJcrwDO);

		//完成
		if(taskVO.getRwZt()==Integer.parseInt( TaskStatusConstant.DOSAVE.getValue())) {
			//通过任务ID去查询
			tJcrwDO = tJcrwDao.selectByPrimaryKey(tJcrwDO.getRwId());
			if (tJcrwDO==null || tJcrwDO.getRwlx().equals(TaskStatusConstant.CBLCODE.getValue())) {
				return null;
			}

			if (tJcrwDO.getJcjssjDate()==null || dateCompare(DateUtil.getNowDate(), tJcrwDO.getJckssjDate(), tJcrwDO.getJcjssjDate())) {
				//完成
				tJcrwDO.setRwZt(Integer.parseInt( TaskStatusConstant.DOSAVE.getValue()));
			}else {
				//超期完成
				tJcrwDO.setRwZt(Integer.parseInt( TaskStatusConstant.ARTIMESAVE.getValue()));
			}
		}
		 tJcrwDao.updateByPrimaryKeySelective(tJcrwDO);
		 LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);
			TaskVO taskV=new TaskVO();
			taskV.setJhId(taskVO.getJhId());
			List<TaskVO> selectDateNo = tJcrwDao.selectDateNo(taskV);
			taskV.setRwZt(Integer.parseInt( TaskStatusConstant.ARYXF.getValue()));
			TJcrwDO tJcrwDO2=new TJcrwDO();
			LsBeanUtils.copyAllProperties(taskV,tJcrwDO2);
			List<TJcrwDO> tJcrwDOs= tJcrwDao.getTaskDate(tJcrwDO2);
			if (tJcrwDOs.size()==selectDateNo.size()) {
				taskVO.setRemark(String.valueOf("0"));
			}else {
				taskVO.setRemark(String.valueOf("1"));
			}

			// 更改TFile原来数据库的status
			List<TFileDO> doList4 = fileDao.selectBySjid(taskVO.getRwId());
			if(doList4 != null&&doList4.size()>0){
				fileDao.deleteBySjId(doList4.get(0));
//				for (TFileDO tFileDO : doList4) {
//					tFileDO.setStatus(0);
//					fileDao.updateByPrimaryKeySelective(tFileDO);
//				}
			}
			// 新增TFileDO
			List<FileVO> voList4 = taskVO.getFile();
			if(voList4 != null&&voList4.size()>0){
				for (FileVO fileVO : voList4) {
					TFileDO tFileDO = new TFileDO();
					fileVO.setSjId(taskVO.getRwId());
					fileVO.setStatus(1);
					LsBeanUtils.copyAllProperties(fileVO, tFileDO);
					fileDao.insertSelective(tFileDO);
				}
			}
		 return taskVO;
	}

	/**
	 * 获取任务ID主键策略方法  计划编号+001 格式
	 * @return
	 */
	public String getTaskRwId(String jhId) {
		return this.getMaxCodeById(tJcrwDao.getMaxCodeById(jhId), jhId, 3);
	}

	/**
	 *  检查任务子项目数据删除
	 * @param rwId
	 */
	public void deleteCheckItems(String rwId) {
		tRwjcxmDao.deleteByRwKey(rwId);
	}

	/**
	 * 检查任务子项目数据新增
	 * @param taskCheckItemsVO
	 */
	public void insertCheckItems(TaskCheckItemsVO taskCheckItemsVO) {
		TRwjcxmDO tRwjcxmDO=new TRwjcxmDO();
		LsBeanUtils.copyAllProperties(taskCheckItemsVO, tRwjcxmDO);
		tRwjcxmDO.setId(new Double(Math.round(Math.random()*5000*10000)).longValue());
	    tRwjcxmDao.insert(tRwjcxmDO);
	}

	/**
	 * 检查任务内容数据删除
	 * @param rwId
	 */
	public void taskcheckContentDelete(String rwId) {
		tJcnrDao.deleteByRwKey(rwId);
	}

	/**
	 * 检查任务内容数据新增
	 * @param checkContentVO
	 */
	public void inspectionJcnrSave(CheckContentVO checkContentVO) {
		TJcnrDO tJcnrDO=new TJcnrDO();
		LsBeanUtils.copyAllProperties(checkContentVO, tJcnrDO);
	    tJcnrDO.setId(new Double(Math.round(Math.random()*50000*100)).longValue());
	    tJcnrDao.insert(tJcnrDO);
	}

	/**
	 * 判断日期是否在指定范围内
	 * @param date  需要比较的时间
	 * @param date1 开始时间
	 * @param date2 结束时间
	 * @return true -在 ; false-不在;
	 */
	//时间比较
	 public static boolean dateCompare(Date date,Date date1, Date date2) {
	       //是否在指定区间
	        boolean isInRange =false;
	        //转化数字
	        long timeOne = date.getTime();
	        long timeTwo= date1.getTime();
	        long timeThree = date2.getTime();
	        //在指定区间
	        if (timeOne>=timeTwo&&timeOne<=timeThree) {
	        	isInRange=true;
			}
	        return isInRange;
	    }

	/**
	 * inspectionTaskGdGl  检查任务-归档管理
	 * @param taskVO
	 * @return
	 */
	public TaskVO inspectionTaskGdGl(TaskVO taskVO) {
		TJcrwDO tJcrwDO =new TJcrwDO();
		LsBeanUtils.copyAllProperties(taskVO, tJcrwDO);

		tJcrwDO.setRwZt(Integer.parseInt( TaskStatusConstant.ARGOD.getValue()));
		tJcrwDO.setSfck("0");
		//归档表
		tJcrwDao.saveByRwEntity(tJcrwDO);
		//已归档
		tJcrwDO.setStatus(0);
		tJcrwDao.updateByPrimaryKeySelective(tJcrwDO);
		return taskVO;
	}

	/**
	 *  制定任务 根据计划ID查询列表
	 * @param jhId
	 * @return
	 */
	public List<TaskPlanVo> getPlanList(String jhId) {
		TaskVO taskVO =new TaskVO();
		taskVO.setJhId(jhId);
		List<TaskVO>	taskV=tJcrwDao.selectDateNo(taskVO);
		if (taskV==null) {
			return null;
		}

		List<TaskPlanVo> taskPlanVo=new ArrayList<TaskPlanVo>();

		List<TJcrwDO> tJcrwList=new ArrayList<TJcrwDO>();
		LsBeanUtils.copyCollection(taskV, tJcrwList, TJcrwDO.class);
		//遍历查询
		for (TJcrwDO taskVList : tJcrwList) {
			TJcrwDO tJcrwDO =new TJcrwDO();
			TaskPlanVo  taskPlan=new TaskPlanVo();
			taskPlan.setJcdwId(taskVList.getJcdwId());
			taskPlan.setJcdwmc(taskVList.getJcdwmc());
			taskPlan.setJhId(jhId);
			if(org.apache.commons.lang3.StringUtils.isNotEmpty(taskVList.getRwId())) {
				taskPlan.setChangeVOs(taskChangeDao.selectRwBgList(taskVList.getRwId()));
			}

			taskPlan.setRwlx(taskVList.getRwlx());
			taskPlan.setRwlxName(taskVList.getRwlxName());
			taskPlan.setRwName(taskVList.getRwName());
			taskPlan.setRwId(taskVList.getRwId());
			//任务状态是待下发的时候也就是2,此时检查组数量0
			if(taskVList.getRwZt()!=null && taskVList.getRwZt()==1){
				taskPlan.setJczsl(0);
			}else{
				taskPlan.setJczsl(tJczDao.selectByTaskId(taskVList.getRwId()).size());
			}
			taskPlan.setRwZt(taskVList.getRwZt());
			tJcrwDO.setRwId(taskVList.getRwId());
			tJcrwDO.setRwZt(Integer.parseInt( TaskStatusConstant.DOSAVE.getValue()));
			// ===========================================================================
			//taskPlan.setWcsl(tJcrwDao.getPlan(tJcrwDO).size());
			// 特殊处理
			// 安全生产 加一条子任务，检查组+1，子任务+1
			List<String> rwCount = tJcrwDao.getPlanJCJG(jhId,taskVList.getRwId(),null); // 该计划下所有子任务
			if(("5000180").equals(taskVList.getRwlx())) {
				taskPlan.setJczsl(rwCount.size()); // 检查组数=子任务数
			}
			// 任务完成数量
			String jgTbbhStr = "";
			if(("5000110").equals(taskVList.getRwlx())) {
				jgTbbhStr = "'0','2','18'";
			} else {
				jgTbbhStr = "'0','2'";
			}
			taskPlan.setWcsl(tJcrwDao.getPlanJCJG(jhId,taskVList.getRwId(),jgTbbhStr).size());
			taskPlan.setSfck(taskVList.getSfck());
			taskPlan.setCkr(taskVList.getCkr());
			taskPlan.setCksj(taskVList.getCksj());
			taskPlan.setWwcsl(rwCount.size()-taskPlan.getWcsl());
			taskPlanVo.add(taskPlan);
		}
		return taskPlanVo;
	}

	/**
	 *  新增/更新检查任务
	 * @param taskVO
	 * @return
	 */
	public TaskVO inspectionEditJcDate(TaskVO taskVO) {
		List<InspectionUnitVO> inspectionUnitVOList = taskVO.getInspectionUnitVO();
		if (inspectionUnitVOList==null) {
			return null;
		 }
		for (InspectionUnitVO inspectionUnitVO : inspectionUnitVOList) {

			 taskVO.setJcdwId(inspectionUnitVO.getJcdwId());
			 taskVO.setJcdwmc(inspectionUnitVO.getJcdwName());
			 taskVO.setStatus(1);
			if(StringUtils.isEmpty(taskVO.getRwId())) {
				//储备量日常检查
				if (StringUtils.isEmpty(taskVO.getJhId())) {
					taskVO.setJhId(this.getMaxCodeById(tJcrwDao.getMaxCodeById("NM" + DateUtil.getDate()),  "NM" + DateUtil.getDate(), 3));
				}
				taskVO.setRwId(this.getMaxCodeById(tJcrwDao.getMaxCodeById(taskVO.getJhId()), taskVO.getJhId(), 3));
				taskVO.setSfck("0");
				tJcrwDao.insertTaskEntity(taskVO);
			}else {
				TJcrwDO tJcrwDO =new TJcrwDO();
				LsBeanUtils.copyAllProperties(taskVO, tJcrwDO);
				tJcrwDao.updateByPrimaryKeySelective(tJcrwDO);
				//删除组员
				TJczzyDO tJczzyDO=new TJczzyDO();
				tJczzyDO.setRemark(taskVO.getRwId());
				tJczzyDao.deleteByRwId(tJczzyDO);

				//删除被检企业
				TBjdwDO tBjdwDO = new TBjdwDO();
				tBjdwDO.setRwId(taskVO.getRwId());
				tBjdwDao.delete(tBjdwDO.getRwId());

				// 删除TFile
				TFileDO tFileDO=new TFileDO();
				tFileDO.setSjId(taskVO.getRwId());
				fileDao.deleteBySjId(tFileDO);

			}
				//获取组员表 新增组员 / 组长 new Double(Math.round(Math.random()*500*100)).longValue()
				if (taskVO.getMembers()!=null) {
					List<MemberVO> membersList = taskVO.getMembers();
					List<TJczzyDO> tJczzyDOList=new ArrayList<TJczzyDO>();
					LsBeanUtils.copyCollection(membersList, tJczzyDOList, TJczzyDO.class);
					TJczzyDO tJczzyDO=new TJczzyDO();
					for (TJczzyDO tJczzys : tJczzyDOList) {
						tJczzyDO.setId(new Double(Math.round(Math.random()*500*100)).longValue());
						tJczzyDO.setJczId(tJczzyDO.getId());
						tJczzyDO.setZyId(tJczzys.getZyId());
						tJczzyDO.setZylx(tJczzys.getZylx());
						tJczzyDO.setZyName(tJczzys.getZyName());
						//组员的任务ID
						tJczzyDO.setRemark(taskVO.getRwId());
						tJczzyDao.insert(tJczzyDO);
					}
				}
				//获取被检企业数据 InspectedUnitsVO TBjdwDO
				if (taskVO.getInspectedUnitsVO()!=null) {
					List<InspectedUnitsVO> inspectedUnitsVOList = taskVO.getInspectedUnitsVO();
					List<TBjdwDO> tBjdwDOList=new ArrayList<TBjdwDO>();
					LsBeanUtils.copyCollection(inspectedUnitsVOList, tBjdwDOList, TBjdwDO.class);
					TBjdwDO tBjdwDO = new TBjdwDO();
					for (TBjdwDO tBjdws : tBjdwDOList) {
						tBjdwDO.setId(new Double(Math.round(Math.random()*500*100)).longValue());
						tBjdwDO.setRwId(taskVO.getRwId());
						tBjdwDO.setBjdwId(tBjdws.getBjdwId());
						tBjdwDO.setBjdwName(tBjdws.getBjdwName());
						tBjdwDO.setBjdwFzr(tBjdws.getBjdwFzr());
						tBjdwDO.setBjdwFzrPhone(tBjdws.getBjdwFzrPhone());
						tBjdwDO.setBjdwAddress(tBjdwDO.getBjdwAddress());
						tBjdwDao.insert(tBjdwDO);
					}
				}
		    	//上传附件
				if (taskVO.getFile()!=null) {
					List<FileVO> voList4 = taskVO.getFile();
					for (FileVO fileVO : voList4) {
						TFileDO tFileDO = new TFileDO();
						fileVO.setSjId(taskVO.getRwId());
						fileVO.setStatus(1);
						LsBeanUtils.copyAllProperties(fileVO, tFileDO);
						fileDao.insertSelective(tFileDO);
					}
		}
		}
		return taskVO;
	}

	/**
	 * 查询数据
	 * @param taskQueryVO
	 * @return
	 */
	public List<TaskVO> inspectionTaskMain(TaskQueryVO taskQueryVO) {
			taskQueryVO.setRwZt(Integer.parseInt( TaskStatusConstant.ARYXF.getValue()));
			taskQueryVO.setJckssjDate(DateUtil.getNowDate());
			List<TJcrwDO> tJcrwDOs = tJcrwDao.findPageList(taskQueryVO);
			List<TaskVO> taskVOs = new ArrayList<TaskVO>();
			for(TJcrwDO tJcrwDO :tJcrwDOs) {
				TaskVO taskVO = new TaskVO();
				LsBeanUtils.copyAllProperties(tJcrwDO, taskVO);
				//检查组组员
				ArrayList<MemberVO> memberVOList = new ArrayList<MemberVO>();
				TJczzyDO tJczzyD=new TJczzyDO();
				tJczzyD.setRemark(tJcrwDO.getRwId());
				List<TJczzyDO> tJczzyDOList = tJczzyDao.selectByQuery(tJczzyD);
				for (TJczzyDO tJczzyDO : tJczzyDOList) {
					MemberVO vo = new MemberVO();
					LsBeanUtils.copyAllProperties(tJczzyDO, vo);
					memberVOList.add(vo);
				}
				taskVO.setMembers(memberVOList);



				//被检查单位查询
				ArrayList<InspectedUnitsVO> inspectedUnitsVOList  = new ArrayList<InspectedUnitsVO>();
				List<TBjdwDO>tBjdwDOList=tBjdwDao.selectByQuery(tJcrwDO.getRwId());
				for (TBjdwDO tBjdwDO : tBjdwDOList) {
					InspectedUnitsVO vo = new InspectedUnitsVO();
					LsBeanUtils.copyAllProperties(tBjdwDO, vo);
					inspectedUnitsVOList.add(vo);
				}
				taskVO.setInspectedUnitsVO(inspectedUnitsVOList);
				taskVOs.add(taskVO);
			}
		return taskVOs;
	}

	/**
	 * @Title: inspectionJhTaskCq
	 * @Description:方法描述:(这里用一句话描述这个方法的作用)
	 * @param @param taskQueryVO
	 * @param @return    设定文件
	 * @return List<TaskVO>    返回类型
	 * @throws
	*/
	public List<TaskVO> inspectionJhTaskCq(TaskQueryVO taskQueryVO) {
		taskQueryVO.setRwZt(Integer.parseInt( TaskStatusConstant.ARYXF.getValue()));
		TJcrwDO tJcrwDO=new TJcrwDO();
		LsBeanUtils.copyAllProperties(taskQueryVO, tJcrwDO);
		List<TJcrwDO> tJcrwDOs = tJcrwDao.getPlan(tJcrwDO);
		if(tJcrwDOs==null) {
			return null;
		}
		List<TaskVO> taskVOs = new ArrayList<TaskVO>();
		LsBeanUtils.copyCollection(tJcrwDOs, taskVOs, TaskVO.class);
	return taskVOs;
	}

	/**
	 * 通过检查组人员查询任务列表
	 * @param zyId
	 * @return
	 */
	public List<String> getTaskListByZyId(String zyId) {
		return tJcrwDao.getTaskListByZyId(zyId);
	}

	/**
	 * 通过任务列表查询组员人数
	 * @param rwIdList
	 * @return
	 */
	public Integer getCountByRwIdList(List<String> rwIdList) {
		return tJcrwDao.getCountByRwIdList(rwIdList);
	}

	/**
	 *
	 * @Description: 通过任务下发人查询任务Id列表
	 * @author: 王帅
	 * @param: @param  makersId
	 * @param: @return 参数
	 * @return: List<String> 返回类型
	 */
	public List<String> getTaskIdsByMakers(List<String> makersId) {
		if (CollectionUtils.isEmpty(makersId)) {
			return null;
		}
		Example example = new Example(TJcrwDO.class);
		Criteria criteria = example.createCriteria();
		criteria.andIn("userId", makersId);
		criteria.andEqualTo("status", 1);
		List<TJcrwDO> entityList = tJcrwDao.selectByExample(example);
		if (CollectionUtils.isNotEmpty(entityList)) {
			Set<String> taskIds = entityList.stream().map(TJcrwDO::getRwId)
					.collect(Collectors.toCollection(TreeSet::new));
			return Lists.newArrayList(taskIds);
		}
		return null;
     }

	/**
	 * 根据计划编号和被检单位编号查询任务列表
	 * @param jhId
	 * @param bjdwId
	 * @return
	 */
	public List<TaskVO> getTaskInfoByjhId(String jhId, String bjdwId) {
		List<TaskVO> taskVOList = new ArrayList<>();
		List<TJcrwDO> tJcrwDOList = tJcrwDao.getTaskInfoByjhId(jhId,bjdwId);
		LsBeanUtils.copyCollection(tJcrwDOList, taskVOList, TaskVO.class);
		return taskVOList;
	}

	/**
	 *
	 * @Description: 通过组织机构Id或是创建人集合查询检查计划主键集合
	 * @author: 王帅
	 * @param: @param  orgCode
	 * @param: @param  makersId
	 * @param: @return 参数
	 * @return: List<String> 返回类型
	 */
	public List<String> getPlanIdsByOrgCodeOrMakers(String orgCode, List<String> makersId, String taskStatus) {
		Example example = new Example(TJcrwDO.class);
		Criteria criteria = example.createCriteria();
		if (CollectionUtils.isNotEmpty(makersId)) {
			criteria.andIn("userId", makersId);
		}
		if (StringUtils.isNotEmpty(orgCode)) {
			criteria.andEqualTo("orgId", orgCode);
		}
		if(StringUtils.isNotEmpty(taskStatus)) {
			criteria.andEqualTo("rwZt", taskStatus);
		}
		criteria.andEqualTo("status", 1);
		List<TJcrwDO> entityList = tJcrwDao.selectByExample(example);
		if (CollectionUtils.isNotEmpty(entityList)) {
			Set<String> planIds = entityList.stream().map(TJcrwDO::getJhId)
					.collect(Collectors.toCollection(TreeSet::new));
			return Lists.newArrayList(planIds);
		}
		return null;
	}

	public TaskChangeVO apply(TaskChangeVO taskChangeVO) {

		taskChangeVO.setTjr(CurrentUtil.getUserName());
		taskChangeVO.setTjsj(new Date());
		taskChangeVO.setId(UUID.randomUUID().toString());

		TJcrwDO tJcrwDO = tJcrwDao.selectByPrimaryKey(taskChangeVO.getRwId());
		if (tJcrwDO == null) {
			throw new RuntimeException("该任务不存在");
		}

		int i = taskChangeDao.apply(taskChangeVO);
		TaskVO taskVO = new TaskVO();
		taskVO.setRwId(taskChangeVO.getRwId());
		taskVO.setRwZt(7);
		taskVO.setRwZtmc("待审核");
		backlogService.addNeedToDeals(taskChangeVO.getRwId(), tJcrwDO.getJcdwmc() + "（"+tJcrwDO.getRwName()+"）任务变更/终止待审核", "7", "待审核", taskChangeVO.getItemUrl(), taskChangeVO.getItemQuery(),taskChangeVO.getItemQueryHaveDone(),taskChangeVO.getItemUrlHaveDone(), taskChangeVO.getUserList());
		if(i>0) {
			tJcrwDao.updateTaskStatusAndDate(taskVO);
		}
		return taskChangeVO;
	}

	public TaskChangeVO taskExamine(TaskChangeVO taskChangeVO) {
		taskChangeVO.setSpr(CurrentUtil.getUserName());
		taskChangeVO.setSpsj(new Date());

		TaskChangeVO changeVO = taskChangeDao.selectChntent(taskChangeVO.getRwId());
		int i = taskChangeDao.taskExamine(taskChangeVO);
		TaskVO taskVO = new TaskVO();
		taskVO.setRwId(taskChangeVO.getRwId());
		if(taskChangeVO.getShjg().equals("1")) {//审批通过并且延期
			if(taskChangeVO.getSqlx().equals("1")) { //延期
				if(changeVO!=null) {
					taskVO.setJcjssjDate(changeVO.getYqd());
				}
				taskVO.setRwZt(0);
				taskVO.setRwZtmc("待分配");
				backlogService.addDeals(taskChangeVO.getRwId(), null, "0", "待分配");
			} else { //终止
				taskVO.setRwZt(8);
				taskVO.setRwZtmc("已终止");
				backlogService.addDeals(taskChangeVO.getRwId(), null, "8", "已终止");
			}
		} else {
			taskVO.setRwZt(0);
			taskVO.setRwZtmc("待分配");
			backlogService.addDeals(taskChangeVO.getRwId(), null, "0", "待分配");
		}
//		tJcrwDao.updateTaskStatusAndDate(taskVO);
//		if(i>0) {
		if(taskVO!=null) {
			tJcrwDao.updateTaskStatusAndDate(taskVO);
		}

//		}
		return taskChangeVO;
	}

	public List<String> taskList(ResultApplyQuery taskChangeVO) {
		return tJcrwDao.taskList(taskChangeVO);
	}

	/**
	 * 更新检查人信息
	 * @param taskVO
	 */
	public void updateTJczzy(TaskVO taskVO) {
		//删除组员
		TJczzyDO tJczzyDO=new TJczzyDO();
		tJczzyDO.setRemark(taskVO.getRwId());
		tJczzyDao.deleteByRwId(tJczzyDO);

		//获取组员表 新增组员 / 组长 new Double(Math.round(Math.random()*500*100)).longValue()
		if (taskVO.getMembers()!=null) {
			List<MemberVO> membersList = taskVO.getMembers();
			List<TJczzyDO> tJczzyDOList=new ArrayList<TJczzyDO>();
			LsBeanUtils.copyCollection(membersList, tJczzyDOList, TJczzyDO.class);
			TJczzyDO tJczzyDO2=new TJczzyDO();
			for (TJczzyDO tJczzys : tJczzyDOList) {
				tJczzyDO2.setId(new Double(Math.round(Math.random()*500*100)).longValue());
				tJczzyDO2.setJczId(tJczzyDO2.getId());
				tJczzyDO2.setZyId(tJczzys.getZyId());
				tJczzyDO2.setZylx(tJczzys.getZylx());
				tJczzyDO2.setZyName(tJczzys.getZyName());
				//组员的任务ID
				tJczzyDO2.setRemark(taskVO.getRwId());
				tJczzyDao.insert(tJczzyDO2);
			}
		}
	}
}
