package com.unis.inspectiontask.server.entity;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
/**
 * 
 * @author 张琪 
 * @description 日常检查任务实体类
 */
@ToString
@SuppressWarnings("serial")
@Getter
@Setter
@Table(name = "T_JCRW")
public class TJcrwDO extends BaseEntity {
	/**
	 * 任务编号 (计划id + 001)
	 */
	@Id
	@Column(name = "RW_ID")
	private String rwId; 
	/**
	 * 任务名称
	 */
	@Column(name = "RW_NAME")
	private String rwName; 
	/**
	 * 计划编号
	 */
	@Column(name = "JH_ID")
	private String jhId; 
	/**
	 * 检查方式（0，远程。1、现场）
	 */
	@Column(name = "JCFS")
	private Integer jcfs; 
	/**
	 * 检查组取得方式（0，指定。1、双随机。2、指定被检单位。）
	 */
	@Column(name = "JCZQDFS")
	private Integer jczqdfs; 
	/**
	 * 检查单位id
	 */
	@Column(name = "JCDW_ID")
	private String jcdwId; 
	/**
	 * 检查单位名称
	 */
	@Column(name = "JCDWMC")
	private String jcdwmc; 
	/**
	 * 下发人
	 */
	@Column(name = "USER_ID")
	private String userId; 
	
	/**
	 * 组织ID
	 */
	@Column(name = "ORG_ID")
	private String orgId; 
	
	/**
	 * 下发人名称
	 */
	@Column(name = "USER_NAME")
	private String userName; 
	/**
	 * 下发时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@Column(name = "XF_TIME")
	private Date xfTime; 
	/**
	 * 任务状态（0、待分配。1、待下发。2、已下发。3、已完成  4、已超期  5、超期完成  6、已归档 ）
	 */
	@Column(name = "RW_ZT")
	private Integer rwZt; 
	
	/**
	 * 检查项目类型（0、单项检查  1、综合检查）
	 */
	@Column(name = "JCXM_LX")
	private Integer jcxmlx; 
	
	/**
	 * 被检单位选择类型（被检单位选择方式(0,单一 1，组合)）
	 */
	@Column(name = "BJDW_XZFS")
	private Integer bjdwxzfs; 

	/**
	 * 任务类型(0、日常检查)
	*/
	@Column(name = "RWLX")
	private String rwlx;
	
	
	/**
	 * 任务类型(0、日常检查)
	 */
	@Column(name = "RWLX_NAME")
	private String rwlxName;
	
	/**
	 * 是否显示
	 */
	@Column(name = "SFXS")
	private Integer sfxs;
	
	/**
	 *检查开始时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	@Column(name = "JCKSSJ_DATE")
	private Date jckssjDate;
	
	/**
	 *检查结束时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	@Column(name = "JCJSSJ_DATE")
	private Date jcjssjDate;
	
	/**
	 * 检查依据
	 */
	@Column(name = "INSPECTION_BASIS")
	private String inspectionBasis;
	
	/**
	 * 检查内容
	 */
	@Column(name = "CHECK_CONTENT")
	private String checkContent;
	
	
	@Column(name = "sfck")
	private String sfck;
	
	@Column(name = "ckr")
	private String ckr;
	
	@Column(name = "cksj")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	@JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
	private Date cksj;
	
	
}