package com.unis.inspectiontask.server.entity;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * @ClassName: TJczzyDO 
 * @Description: 检查组组员实体类 
 * @author LiuFeng 
 * @date 2019年8月24日 下午4:25:20
 */
@ToString
@SuppressWarnings("serial")
@Getter
@Setter
@Table(name = "T_JCZZY")
public class TJczzyDO extends BaseEntity{
	
	/**
	 * 主键id
	 */
	@Id
	@Column(name = "ID")
    private Long id;

	/**
	 * 检查组id
	 */
	@Column(name = "JCZ_ID")
    private Long jczId;

	/**
	 * 组员id
	 */
	@Column(name = "ZY_ID")
    private String zyId;

	/**
	 * 组员名称
	 */
	@Column(name = "ZY_NAME")
    private String zyName;

	/**
	 * 组员部门
	 */
	@Column(name = "ZYKS")
    private String zyks;

	/**
	 * 组员单位
	 */
	@Column(name = "ZYDW")
    private String zydw;

	/**
	 * 组员类型
	 */
	@Column(name = "ZYLX")
    private Integer zylx;

	/**
	 * 是否持证 0:否 1:是
	 */
	@Column(name = "IS_CZ")
    private Integer isCz;

	/**
	 * 国家证书编号
	 */
	@Column(name = "ZFZBH")
	private String zfzbh;

	/**
	 * 市级证书编号
	 */
	@Column(name = "S_ZFZBH")
	private String cityCardNum;
	
	private String rysjh;

	@ApiModelProperty(value = "人才库id")
	private String rckid;

	@ApiModelProperty(value = "座机")
	private String zj;

}