/**
 * @Title: EvasionService.java
 * @Package com.unis.inspectiontask.server.service
 * @Description:
 * @author LiuFeng
 * @date 2019年8月24日 下午2:29:09
 * @version V1.0
 */
package com.unis.inspectiontask.server.service;

import java.util.List;

import com.unis.inspectiontask.common.vo.EvasionQueryVO;
import com.unis.inspectiontask.common.vo.EvasionVO;

/**
 * @ClassName: EvasionService
 * @Description:
 * @author LiuFeng
 * @date 2019年8月24日 下午2:29:09
 */
public interface EvasionService {

	/**
	 * @Title: saveRecords
	 * @Description: 保存规避记录
	 * @param evasionVOs
	 * @return int
	 * @throws
	 */
	int saveRecords(List<EvasionVO> evasionVOs);

	/**
	 * @Title: queryRecordsList
	 * @Description:
	 * @param queryVO
	 * @return List<EvasionVO>
	 * @throws
	 */
	List<EvasionVO> queryRecordsList(EvasionQueryVO queryVO);

	/**
	 * @Title: queryRecordsByRwId
	 * @Description: 根据任务id查询规避列表
	 * @param rwId
	 * @throws
	 */
	List<EvasionVO> queryRecordsByRwId(String rwId);

}
