package com.unis.inspectiontask.server.service;

import java.util.List;

import com.github.pagehelper.PageInfo;
import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.*;

public interface TaskService {

	/**
	 * @deprecated 分页查询所有检查任务数据
	 * @param taskQueryVO
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	public PageInfo<TaskVO> getRwTaskPageList(TaskQueryVO taskQueryVO, Integer pageNum, Integer pageSize);

	/**
	 * @param taskQueryVO
	 * @return
	 */
	public List<TaskVO> exportTask(TaskQueryVO taskQueryVO);

	/**
	 * @param rwbh 任务编号
	 * @return
	 */
	public TaskVO getTaskInfoByrwbh(String rwId);

	/**
	 * @param taskVO
	 * @return
	 */
	public List<TaskVO> selectDateNo(TaskVO taskVO);

	/**
	 * @param rwId
	 */
	public void delete(String rwId);


	/**
	 * @param rwlx
	 * @Title: getTaskListByRybh
	 * @Description:
	 * @param rybh
	 * @return Integer
	 * @throws
	 */
	public List<TaskVO> getTaskListByRybh(String rybh, String rwlx);

	public List<TaskVO> getTaskSimpleListByRybh(String rybh, String rwlx);

	/**
	 * 查询所有信息数据
	 * @param taskVO
	 * @return
	 */
	public TaskVO getTaskInfoAll(TaskVO taskVO);

	/**
	 * 制定任务新增接口
	 * @param taskVO
	 * @return
	 */
	public int inspectionTaskInsert(TaskVO taskVO);

	/**
	 *  分配暂存
	 * @param taskVO
	 */
	public int inspectionTaskDistribution(TaskVO taskVO);

	/**
	 * 下发新增
	 * @param taskVO
	 */
	public void updateInspectionTask(TaskVO taskVO);

	/**
	 * 修改任务状态
	 * @param rwId 任务编号
	 * @param rwZt 任务状态
	 */
	public Integer updateTaskStatus(String rwId, Integer rwZt);

	/**
	 * @param taskTeamVO
	 * 检查组和检查任务新增接口
	 */
	public String inspectionTaskInsertTeam(TaskTeamVO taskTeamVO);

	/**
	 * 根据计划ID获取数据信息
	 * @param jhId
	 * @return
	 */
	public List<TaskVO> inspectionTaskGetDate(String jhId);


	/**
	 *  获取任务ID主键策略方法  计划编号+001 格式
	 * @param jhId
	 * @return
	 */
	public String getTaskRwId(String jhId);

	/**
	 * 检查任务数据 新增Add
	 * @param taskVO
	 */
	public void inspectionSaveJcDate(TaskVO taskVO);

	/**
	 *  检查任务数据 删除Remove
	 * @param rwId
	 */
	public void inspectionTaskDelete(String rwId);

	/**
	 * 检查任务数据 删除
	 * @param taskVO
	 * @return
	 */
	public ResponseWrapper deleteByEntity(TaskVO taskVO);

	/**
	 * 检查任务子项目数据删除
	 * @param rwId
	 */
	public void inspectionTaskCheckItemsDelete(String rwId);

	/**
	 * 检查任务子项目数据新增
	 * @param taskCheckItemsVO
	 */
	public void inspectionJczxSave(TaskCheckItemsVO taskCheckItemsVO);

	/**
	 * 检查任务内容删除
	 * @param rwId
	 */
	public void inspectionTaskcheckContentDelete(String rwId);

	/**
	 *  检查任务内容新增
	 * @param checkContentVO
	 */
	public void inspectionJcnrSave(CheckContentVO checkContentVO);

	/**
	 *  检查任务修改
	 * @param taskVO
	 */
	public TaskVO inspectionTaskUpdate(TaskVO taskVO);

	/**
	 * 检查任务-归档管理
	 * @param taskVO
	 * @return
	 */
	public TaskVO inspectionTaskGdGl(TaskVO taskVO);

	/**
	 *  制定任务 根据计划ID查询列表
	 * @param jhId
	 * @return
	 */
	public List<TaskPlanVo> getPlanList(String jhId);

	/**
	 * 更新检查任务
	 * @param taskVO
	 * @return
	 */
	public TaskVO inspectionEditJcDate(TaskVO taskVO);

	/**
	 * 任务检查 【数据】
	 * @param taskQueryVO
	 * @return
	 */
	public List<TaskVO> inspectionTaskMain(TaskQueryVO taskQueryVO);

	/**
	 * @Title: inspectionJhTaskCq
	 * @Description:方法描述:(这里用一句话描述这个方法的作用)
	 * @param @param taskQueryVO
	 * @param @return    设定文件
	 * @return List<TaskVO>    返回类型
	 * @throws
	*/
	public List<TaskVO> inspectionJhTaskCq(TaskQueryVO taskQueryVO);

	/**
	 * 通过检查组人员查询任务列表
	 * @param zyId
	 * @return
	 */
    List<String> getTaskListByZyId(String zyId);

	/**
	 * 通过任务列表查询组员人数
	 * @param rwIdList
	 * @return
	 */
	Integer getCountByRwIdList(List<String> rwIdList);

	/**
	 *
	 * @Description: 通过任务下发人查询任务Id列表
	 * @author: 王帅
	 * @param: @param  makersId
	 * @param: @return 参数
	 * @return: List<String> 返回类型
	 */
	public List<String> getTaskIdsByMakers(List<String> makersId);

	/**
	 * 根据计划编号和被检单位编号查询任务列表
	 * @param jhId
	 * @param bjdwId
	 * @return
	 */
	List<TaskVO> getTaskInfoByjhId(String jhId, String bjdwId);

	/**
	 *
	 * @Description: 通过组织机构Id或是创建人集合查询检查计划主键集合
	 * @author: 王帅
	 * @param: @param  orgCode
	 * @param: @param  makersId
	 * @param: @return 参数
	 * @return: List<String> 返回类型
	 */
	public List<String> getPlanIdsByOrgCodeOrMakers(String orgCode, List<String> makersId, String taskStatus);

	/**
	 * @param taskChangeVO
	 * @return 变更申请
	 */
	public TaskChangeVO taskChange(TaskChangeVO taskChangeVO);

	public TaskChangeVO taskExamine(TaskChangeVO taskChangeVO);

	/**
	 * @param taskChangeVO
	 * @return 查询任务列表
	 */
	public List<String> taskList(ResultApplyQuery taskChangeVO);

	/**
	 * 更新检查人信息
	 */
	public void updateTJczzy(TaskVO taskVO);
}
