/**
 * @Title: EvasionServiceImpl.java
 * @Package com.unis.inspectiontask.server.service.impl
 * @Description:
 * @author LiuFeng
 * @date 2019年8月24日 下午2:30:23
 * @version V1.0
 */
package com.unis.inspectiontask.server.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.unis.inspectiontask.common.vo.EvasionQueryVO;
import com.unis.inspectiontask.common.vo.EvasionVO;
import com.unis.inspectiontask.server.domain.EvasionDomain;
import com.unis.inspectiontask.server.service.EvasionService;

/**
 * @ClassName: EvasionServiceImpl
 * @Description: 规避service实现类
 * @author LiuFeng
 * @date 2019年8月24日 下午2:30:23
 */

@Service("evasionService")
public class EvasionServiceImpl implements EvasionService{

	@Autowired
	private EvasionDomain evasionDomain;

	/**
	 * <p>Title: saveRecords</p>
	 * <p>Description: </p>
	 * @param evasionVOs
	 * @return
	 * @see com.unis.inspectiontask.server.service.EvasionService#saveRecords(java.util.List)
	 */
	@Override
	public int saveRecords(List<EvasionVO> evasionVOs) {

		return evasionDomain.saveRecords(evasionVOs);
	}

	/**
	 * <p>Title: queryRecordsList</p>
	 * <p>Description: </p>
	 * @param queryVO
	 * @return
	 * @see com.unis.inspectiontask.server.service.EvasionService#queryRecordsList(com.unis.inspectiontask.common.vo.EvasionQueryVO)
	 */
	@Override
	public List<EvasionVO> queryRecordsList(EvasionQueryVO queryVO) {

		return evasionDomain.queryRecordsList(queryVO);
	}

	/**
	 * <p>Title: queryRecordsByRwId</p>
	 * <p>Description: </p>
	 * @param rwId
	 * @return
	 * @see com.unis.inspectiontask.server.service.EvasionService#queryRecordsByRwId(java.lang.String)
	 */
	@Override
	public List<EvasionVO> queryRecordsByRwId(String rwId) {

		return evasionDomain.queryRecordsByRwId(rwId);
	}

}
