package com.unis.inspectiontask.server.service.impl;

import com.github.pagehelper.PageHelper;
import com.unis.inspectiontask.common.vo.PerformanceQueryVO;
import com.unis.inspectiontask.common.vo.PerformanceVO;
import com.unis.inspectiontask.common.vo.PersonnelPerformanceQueryVO;
import com.unis.inspectiontask.server.domain.PerformanceDomain;
import com.unis.inspectiontask.server.service.PerformanceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author WangZL
 * @version 1.0
 * @Title PerformanceServiceImpl
 * @ProjectName PerformanceServiceImpl
 * @Description
 * @date 2019/07/22 17点26分
 */
@Service("performanceService")
public class PerformanceServiceImpl implements PerformanceService {

	@Autowired
	private PerformanceDomain performanceDomain;

	/**
	 * 分页展示
	 */
	@Override
	public List<PerformanceVO> getPerformancePage(PerformanceQueryVO performanceQueryVO, Integer pageNum, Integer pageSize) {
		PageHelper.startPage(pageNum, pageSize);
		return performanceDomain.getPerformanceList(performanceQueryVO);
	}

	/**
	 * 检查次数
	 * @param personnelPerformanceQueryVO
	 * @return
	 */
	@Override
	public Integer personnelPerformanceNumber(PersonnelPerformanceQueryVO personnelPerformanceQueryVO) {
		return performanceDomain.personnelPerformanceNumber(personnelPerformanceQueryVO);
	}

}
