package com.unis.inspectiontask.server.service.impl;

import java.util.List;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectiontask.common.vo.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.github.pagehelper.PageInfo;
import com.unis.inspectiontask.server.domain.TaskDomain;
import com.unis.inspectiontask.server.service.TaskService;

@Service("taskService")
public class TaskServiceImpl  implements TaskService{

	@Autowired
	private TaskDomain taskDomain;

	/**
	 * 获取日常检查任务分页列表
	 */
	@Override
	public PageInfo<TaskVO> getRwTaskPageList(TaskQueryVO taskQueryVO, Integer pageNum, Integer pageSize) {
		return taskDomain.getTasksByQuery(taskQueryVO, pageNum, pageSize);
	}

	/**
	 * 任务检查数据-新增
	 */
	@Override
	public void inspectionSaveJcDate(TaskVO  taskVO) {
		taskDomain.insert(taskVO);
	}

	/**
	 * 任务检查数据-删除
	 */
	@Override
	public void inspectionTaskDelete(String rwId) {
		taskDomain.delete(rwId);
	}


	/**
	 * 检查任务数据 删除
	 * @param taskVO
	 * @return
	 */
	public ResponseWrapper deleteByEntity(TaskVO taskVO){
		return taskDomain.deleteByEntity(taskVO);
	}


	/**
	 * 任务列表导出数据
	 */
	@Override
	public List<TaskVO> exportTask(TaskQueryVO taskQueryVO) {
		return taskDomain.findExportList(taskQueryVO);
	}

	/**
	 *  根据任务编号查询
	 */
	@Override
	public TaskVO getTaskInfoByrwbh(String rwId) {
		return taskDomain.getTaskInfoByrwbh(rwId);
	}

	/**
	 * 查询数据是否存在
	 */
	@Override
	public List<TaskVO> selectDateNo(TaskVO taskVO) {
		return taskDomain.selectDateNo(taskVO);
	}
	/**
	 * 删除该条数据（假删）
	 */
	@Override
	public void delete(String rwId) {
		taskDomain.delete(rwId);
	}

	/**
	 * <p>Title: getTaskListByRybh</p>
	 * <p>Description: </p>
	 * @param rybh
	 * @return
	 * @see com.unis.inspectiontask.server.service.TaskService#getTaskListByRybh(java.lang.String)
	 */
	@Override
	public List<TaskVO> getTaskListByRybh(String rybh,String rwlx) {
		return taskDomain.getTaskListByRybh(rybh,rwlx);
	}

	public List<TaskVO> getTaskSimpleListByRybh(String rybh,String rwlx) {
		return taskDomain.getTaskSimpleListByRybh(rybh,rwlx);
	}

	/**
	 * 查询数据详细
	 */
	@Override
	public TaskVO getTaskInfoAll(TaskVO taskVO) {
		return taskDomain.getTaskInfoAll(taskVO);
	}

	/**
	 *  接口新增
	 * @return
	 */
	@Override
	public int inspectionTaskInsert(TaskVO inspectionTaskInsert) {
		return taskDomain.inspectionTaskInsert(inspectionTaskInsert);
	}

	/**
	 * 分配暂存
	 * @return
	 */
	@Override
	public int inspectionTaskDistribution(TaskVO taskVO) {
		return taskDomain.inspectionTaskDistribution(taskVO);
	}

	/**
	 * 下发新增
	 */
	@Override
	public void updateInspectionTask(TaskVO taskVO) {
		taskDomain.inspectionTaskUpdateByEntity(taskVO);
	}

	/**
	 * <p>Title: updateTaskStatus</p>
	 * <p>Description: 修改任务状态</p>
	 * @param rwId
	 * @param rwZt
	 * @return
	 * @see com.unis.inspectiontask.server.service.TaskService#updateTaskStatus(java.lang.String, java.lang.Integer)
	 */
	@Override
	public Integer updateTaskStatus(String rwId, Integer rwZt) {
		return taskDomain.updateTaskStatus(rwId,rwZt);
	}

	/**
	 * 检查组和检查任务新增接口
	 * @return
	 */
	@Override
	public String inspectionTaskInsertTeam(TaskTeamVO taskTeamVO) {
		return taskDomain.inspectionTaskInsertTeam(taskTeamVO);
	}

	/**
	 * 获取计划关联数据是否下发
	 * @return
	 */
	@Override
	public List<TaskVO> inspectionTaskGetDate(String jhId) {
		return taskDomain.getTaskDate(jhId);
	}

	/**
	 *  获取任务ID主键策略方法  计划编号+001 格式
	 */
	@Override
	public String getTaskRwId(String jhId) {
		return taskDomain.getTaskRwId(jhId);
	}

	/**
	 * 检查任务子项目数据删除
	 */
	@Override
	public void inspectionTaskCheckItemsDelete(String rwId) {
		taskDomain.deleteCheckItems(rwId);
	}

	/**
	 * 检查任务子项目数据新增
	 */
	@Override
	public void inspectionJczxSave(TaskCheckItemsVO taskCheckItemsVO) {
		taskDomain.insertCheckItems(taskCheckItemsVO);
	}

	/**
	 * 检查任务内容数据删除
	 */
	@Override
	public void inspectionTaskcheckContentDelete(String rwId) {
		taskDomain.taskcheckContentDelete(rwId);
	}

	/**
	 *  检查任务内容数据新增
	 */
	@Override
	public void inspectionJcnrSave(CheckContentVO checkContentVO) {
		taskDomain.inspectionJcnrSave(checkContentVO);
	}

	/**
	 * 检查任务更新数据
	 * @return
	 */
	@Override
	public TaskVO inspectionTaskUpdate(TaskVO taskVO) {
		return taskDomain.inspectionTaskUpdateByEntity(taskVO);
	}

	/**
	 * inspectionTaskGdGl  检查任务-归档管理
	 */
	@Override
	public TaskVO inspectionTaskGdGl(TaskVO taskVO) {
		return taskDomain.inspectionTaskGdGl(taskVO);
	}

	/**
	 *  制定任务 根据计划ID查询列表
	 */
	@Override
	public List<TaskPlanVo> getPlanList(String jhId) {
		return taskDomain.getPlanList(jhId);
	}

	/**
	 *  更新检查任务
	 * @return
	 */
	@Override
	public TaskVO inspectionEditJcDate(TaskVO taskVO) {
		return taskDomain.inspectionEditJcDate(taskVO);
	}

	/**
	 * 数据查询
	 */
	@Override
	public List<TaskVO> inspectionTaskMain(TaskQueryVO taskQueryVO) {
		return taskDomain.inspectionTaskMain(taskQueryVO);
	}

	/** (非 Javadoc)
	* <p>Title: inspectionJhTaskCq</p>
	* <p>Description: </p>
	* @param taskQueryVO
	* @return
	* @see com.unis.inspectiontask.server.service.TaskService#inspectionJhTaskCq(com.unis.inspectiontask.common.vo.TaskQueryVO)
	*/
	@Override
	public List<TaskVO> inspectionJhTaskCq(TaskQueryVO taskQueryVO) {
		return taskDomain.inspectionJhTaskCq(taskQueryVO);
	}

	/**
	 * 通过检查组人员查询任务列表
	 * @param zyId
	 * @return
	 */
	@Override
	public List<String> getTaskListByZyId(String zyId) {
		return taskDomain.getTaskListByZyId(zyId);
	}

	/**
	 * 通过任务列表查询组员人数
	 * @param rwIdList
	 * @return
	 */
	@Override
	public Integer getCountByRwIdList(List<String> rwIdList) {
		return taskDomain.getCountByRwIdList(rwIdList);
	}

	@Override
	public List<String> getTaskIdsByMakers(List<String> makersId) {
		return taskDomain.getTaskIdsByMakers(makersId);
	}

	/**
	 * 根据计划编号和被检单位编号查询任务列表
	 * @param jhId
	 * @param bjdwId
	 * @return
	 */
	@Override
	public List<TaskVO> getTaskInfoByjhId(String jhId, String bjdwId) {
		return taskDomain.getTaskInfoByjhId(jhId,bjdwId);
	}

	/**
	 *
	 * @Description: 通过组织机构Id或是创建人集合查询检查计划主键集合
	 * @author: 王帅
	 * @param: @param  orgCode
	 * @param: @param  makersId
	 * @param: @return 参数
	 * @return: List<String> 返回类型
	 */
	@Override
	public List<String> getPlanIdsByOrgCodeOrMakers(String orgCode, List<String> makersId, String taskStatus) {
		return taskDomain.getPlanIdsByOrgCodeOrMakers(orgCode, makersId, taskStatus);
	}

	@Override
	public TaskChangeVO taskChange(TaskChangeVO taskChangeVO) {
		return taskDomain.apply(taskChangeVO);
	}

	@Override
	public TaskChangeVO taskExamine(TaskChangeVO taskChangeVO) {
		return taskDomain.taskExamine(taskChangeVO);
	}

	@Override
	public List<String> taskList(ResultApplyQuery taskChangeVO) {
		return taskDomain.taskList(taskChangeVO);
	}

	/**
	 * 更新检查人信息
	 */
	@Override
	public void updateTJczzy(TaskVO taskVO) {
		taskDomain.updateTJczzy(taskVO);
	}
}
