package com.unis.inspectiontask.server.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.unis.inspectiontask.common.constant.TaskStatusConstant;
import com.unis.inspectiontask.common.vo.OrganizeVO;
import com.unis.inspectiontask.common.vo.TeamVO;
import com.unis.inspectiontask.server.domain.TeamDomain;
import com.unis.inspectiontask.server.service.TeamService;

/**
 * @ClassName: TeamServiceImpl
 * @Description: 检查组service实现类
 * @author LiuFeng
 * @date 2019年8月24日 下午5:53:07
 */
@Service("teamService")
public class TeamServiceImpl implements TeamService{

	@Autowired
	private TeamDomain teamDomain;

	/**
	 * <p>Title: saveInspectionTeams</p>
	 * <p>Description: </p>
	 * @param teamVOs
	 * @return
	 * @see com.unis.inspectiontask.server.service.TeamService#saveInspectionTeams(java.util.List)
	 */
	@Override
	public void saveInspectionTeams(List<TeamVO> teamVOs) {
		String rwIdString = "";
		for (TeamVO teamVO : teamVOs) {
			rwIdString=teamVO.getRwId();
			break;
		}
		teamDomain.saveInspectionTeams(teamVOs,rwIdString);
	}

	/**
	 * <p>Title: getInspectionUnit</p>
	 * <p>Description: </p>
	 * @param userId
	 * @return
	 * @see com.unis.inspectiontask.server.service.TeamService#getInspectionUnit(java.lang.String)
	 */
	@Override
	public List<OrganizeVO> getInspectionUnit(String userId) {

		return teamDomain.getInspectionUnit(userId);
	}

	/**
	 * <p>Title: getIinspectionTeamList</p>
	 * <p>Description: </p>
	 * @param taskId
	 * @return
	 * @see com.unis.inspectiontask.server.service.TeamService#getIinspectionTeamList(java.lang.String)
	 */
	@Override
	public List<TeamVO> getIinspectionTeamList(String taskId) {

		return teamDomain.getIinspectionTeamList(taskId);
	}

	/**
	 * <p>Title: updateInspectionTeams</p>
	 * <p>Description: </p>
	 * @param teamVOs
	 * @see com.unis.inspectiontask.server.service.TeamService#updateInspectionTeams(java.util.List)
	 */
	@Override
	public void updateInspectionTeams(List<TeamVO> teamVOs) {
		teamDomain.updateInspectionTeams(teamVOs);
	}

	/**
	 * <p>Title: isIinspectionTeam</p>
	 * <p>Description: </p>
	 * @param jczId
	 * @param orgId
	 * @return
	 * @see com.unis.inspectiontask.server.service.TeamService#isIinspectionTeam(java.lang.Long, java.lang.String)
	 */
	@Override
	public Integer isIinspectionTeam(Long jczId, String orgId) {

		return teamDomain.isIinspectionTeam(jczId,orgId);
	}

	/**
	 * <p>Title: getInspectionTeam</p>
	 * <p>Description: </p>
	 * @param rwId
	 * @param bjdwId
	 * @return
	 * @see com.unis.inspectiontask.server.service.TeamService#getInspectionTeam(java.lang.String, java.lang.String)
	 */
	@Override
	public TeamVO getInspectionTeam(String rwId, String bjdwId) {

		return teamDomain.getInspectionTeam(rwId,bjdwId);
	}

	/**
	 * 根据任务编号删除检查组所有信息
	 */
	@Override
	public void deleteInspectionTeams(String rwId) {
		teamDomain.deleteTeam(rwId);
	}

	/**
	 * 制定任务检查组信息暂存/下发
	 */
	@Override
	public void saveInspectionPlanTeams(List<TeamVO> teamVOs) {
		teamDomain.saveInspectionTeams(teamVOs,TaskStatusConstant.XF.getValue());
	}

	@Override
	public List<String> getTaskIdsListByMemberId(String memberId) {
		return teamDomain.getTaskIdsListByMemberId(memberId);
	}
}
